/*
===============================================================================
   ___________.___ _______  ________    _________._________________________
   \_   _____/|   |\      \ \______ \  /   _____/|   \__    ___/\_   _____/
    |    __)  |   |/   |   \ |    |  \ \_____  \ |   | |    |    |    __)_
    |     \   |   /    |    \|    `   \/        \|   | |    |    |        \
    \___  /   |___\____|__  /_______  /_______  /|___| |____|   /_______  /
        \/                \/        \/        \/                        \/
                                          __        __
                          ____ ___  ___  / /_____ _/ /
                         / __ `__ \/ _ \/ __/ __ `/ / 
                        / / / / / /  __/ /_/ /_/ / /  
                       /_/ /_/ /_/\___/\__/\__,_/_/   

   FINDSITE-METAL predicts metal-binding sites, residues and metal preferences
   from template structures identified by threading

   Make sure you have libf2c, gzstream, zlib and libsvm installed

   This software is distributed WITHOUT ANY WARRANTY

   Please report bugs to michal@gatech.edu

   Center for the Study of Systems Biology
   250 14th Street NW, Atlanta, GA 30318, USA
===============================================================================
*/


#ifndef __COORDS_H_
#define __COORDS_H_

#include<string>
#include<deque>

using namespace std;

// ==================================================================================   CoordsProtein

class CoordsProtein {
        
  private:
    
    int    n; // atom number
    int    r; // residue number
    double x; // x coordinate
    double y; // y coordinate
    double z; // z coordinate
    string t; // residue name
    string a; // atom name

  public:

    CoordsProtein( int, int, double, double, double, string, string );
    
    CoordsProtein( void );

    ~CoordsProtein();

    int getAtomNumber();
    
    int getResidueNumber();
    
    double getCoords( int );
    
    void setCoords( double, double, double );
    
    string getResidueName();
    
    string getAtomName();
};

#endif
