/*
===============================================================================
   ___________.___ _______  ________    _________._________________________
   \_   _____/|   |\      \ \______ \  /   _____/|   \__    ___/\_   _____/
    |    __)  |   |/   |   \ |    |  \ \_____  \ |   | |    |    |    __)_
    |     \   |   /    |    \|    `   \/        \|   | |    |    |        \
    \___  /   |___\____|__  /_______  /_______  /|___| |____|   /_______  /
        \/                \/        \/        \/                        \/
                                          __        __
                          ____ ___  ___  / /_____ _/ /
                         / __ `__ \/ _ \/ __/ __ `/ / 
                        / / / / / /  __/ /_/ /_/ / /  
                       /_/ /_/ /_/\___/\__/\__,_/_/   

   FINDSITE-METAL predicts metal-binding sites, residues and metal preferences
   from template structures identified by threading

   Make sure you have libf2c, gzstream, zlib and libsvm installed

   This software is distributed WITHOUT ANY WARRANTY

   Please report bugs to michal@gatech.edu

   Center for the Study of Systems Biology
   250 14th Street NW, Atlanta, GA 30318, USA
===============================================================================
*/


#ifndef __FINDSITEMETAL_H_
#define __FINDSITEMETAL_H_

#include<fstream>
#include<iostream>
#include<iomanip>
#include<cstring>
#include<sstream>
#include<cstdlib>
#include<vector>
#include<list>
#include<map>
#include<set>
#include<bitset>
#include<ctime>
#include<cmath>
#include<algorithm>

#include "size.h"
#include "walltime.h"
#include "frtmalign.h"
#include "coords.h"
#include "data.h"
#include "template.h"
#include "list.h"
#include "cluster.h"
#include "site.h"
#include "runsvm.h"

#endif
