/*
===============================================================================
   ___________.___ _______  ________    _________._________________________
   \_   _____/|   |\      \ \______ \  /   _____/|   \__    ___/\_   _____/
    |    __)  |   |/   |   \ |    |  \ \_____  \ |   | |    |    |    __)_
    |     \   |   /    |    \|    `   \/        \|   | |    |    |        \
    \___  /   |___\____|__  /_______  /_______  /|___| |____|   /_______  /
        \/                \/        \/        \/                        \/
                                          __        __
                          ____ ___  ___  / /_____ _/ /
                         / __ `__ \/ _ \/ __/ __ `/ / 
                        / / / / / /  __/ /_/ /_/ / /  
                       /_/ /_/ /_/\___/\__/\__,_/_/   

   FINDSITE-METAL predicts metal-binding sites, residues and metal preferences
   from template structures identified by threading

   Make sure you have libf2c, gzstream, zlib and libsvm installed

   This software is distributed WITHOUT ANY WARRANTY

   Please report bugs to michal@gatech.edu

   Center for the Study of Systems Biology
   250 14th Street NW, Atlanta, GA 30318, USA
===============================================================================
*/

/* align.f -- translated by f2c (version 20061008).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#ifdef __cplusplus
extern "C" {
#endif

#include "f2c.h"
#include "nwalign.h"

/* Common Block Declarations */

struct {
    real score[9000000]	/* was [3000][3000] */, gap_open__, gap_extn__;
    integer j2i[3000], nseq1, nseq2;
} dpc_;

#define dpc_1 dpc_

struct {
    integer imut[529]	/* was [23][23] */;
} matra_;

#define matra_1 matra_

/* Main program */ int MAIN_NW__( double *nw_score3a, double *nw_score3b, int nw_len3a, int nw_len3b, int nw_seq3a[], int nw_seq3b[], int nw_ali3[] )
{
    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    integer s_wsle(cilist *), do_lio(integer *, integer *, char *, ftnlen), e_wsle(void);

    /* Local variables */
    static integer i__, j;
    extern /* Subroutine */ int dp2_(real *);
    static integer seq1[3000], seq2[3000], l_id__, l_ali__;
    static real score0;
    extern /* Subroutine */ int matrix_(void);

    /* Fortran I/O blocks */
    
    dpc_1.nseq1 = nw_len3a;
    dpc_1.nseq2 = nw_len3b;
    
    for ( int ii3 = 0; ii3 < nw_len3a; ii3++ )
     seq1[ii3] = nw_seq3a[ii3];
    
    for ( int ii3 = 0; ii3 < nw_len3b; ii3++ )
     seq2[ii3] = nw_seq3b[ii3];
    
    matrix_();

    i__1 = dpc_1.nseq1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = dpc_1.nseq2;
	for (j = 1; j <= i__2; ++j) {
	    dpc_1.score[i__ + j * 3000 - 3001] = (real) matra_1.imut[seq1[i__ 
		    - 1] + seq2[j - 1] * 23 - 24];
	}
    }

    dpc_1.gap_open__ = -12.f;
    dpc_1.gap_extn__ = -1.2f;

    dp2_(&score0);

    l_id__ = 0;
    l_ali__ = 0;
    i__1 = dpc_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	if (dpc_1.j2i[j - 1] > 0) {
	    i__ = dpc_1.j2i[j - 1];
	    ++l_ali__;
	    if (seq1[i__ - 1] == seq2[j - 1]) {
		++l_id__;
	    }
	}
    }
    
    *nw_score3a = (real) l_id__ / (l_ali__ + 1e-8f);
    *nw_score3b = score0;
    
    i__1 = dpc_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
        nw_ali3[j - 1] = dpc_1.j2i[j - 1] - 1;
        
        if ( nw_ali3[j - 1] < -1 ) nw_ali3[j - 1] = -1;
    }
    
    return 0;
} /* MAIN_NW__ */


/* Subroutine */ int dp2_(real *score0)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static real d__, h__;
    static integer i__, j;
    static real v;
    static integer me, jph[9006001]	/* was [3001][3001] */;
    static real val[9006001]	/* was [3001][3001] */;
    static integer jpv[9006001]	/* was [3001][3001] */;
    static real val1, val2;
    static integer idir[9006001]	/* was [3001][3001] */;
    static real preh[9006001]	/* was [3001][3001] */, prev[9006001]	/* was [3001][3001] */;

    val[0] = 0.f;
    i__1 = dpc_1.nseq1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	val[i__] = 0.f;
	idir[i__] = 0;
	jpv[i__] = 1;
	jph[i__] = i__;
	prev[i__] = -1e3f;
    }
    i__1 = dpc_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	val[j * 3001] = 0.f;
	idir[j * 3001] = 0;
	jpv[j * 3001] = j;
	jph[j * 3001] = 1;
	preh[j * 3001] = -1e3f;
    }

    i__1 = dpc_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	i__2 = dpc_1.nseq1;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    d__ = val[i__ - 1 + (j - 1) * 3001] + dpc_1.score[i__ + j * 3000 - 3001];
	    jph[i__ + j * 3001] = 1;
	    val1 = val[i__ - 1 + j * 3001] + dpc_1.gap_open__;
	    val2 = preh[i__ - 1 + j * 3001] + dpc_1.gap_extn__;
	    if (val1 > val2) {
		h__ = val1;
	    } else {
		h__ = val2;
		if (i__ > 1) {
		    jph[i__ + j * 3001] = jph[i__ - 1 + j * 3001] + 1;
		}
	    }
	    jpv[i__ + j * 3001] = 1;
	    val1 = val[i__ + (j - 1) * 3001] + dpc_1.gap_open__;
	    val2 = prev[i__ + (j - 1) * 3001] + dpc_1.gap_extn__;
	    if (val1 > val2) {
		v = val1;
	    } else {
		v = val2;
		if (j > 1) {
		    jpv[i__ + j * 3001] = jpv[i__ + (j - 1) * 3001] + 1;
		}
	    }
	    preh[i__ + j * 3001] = h__;
	    prev[i__ + j * 3001] = v;
	    if (d__ > h__ && d__ > v) {
		idir[i__ + j * 3001] = 1;
		val[i__ + j * 3001] = d__;
	    } else if (h__ > v) {
		idir[i__ + j * 3001] = 2;
		val[i__ + j * 3001] = h__;
	    } else {
		idir[i__ + j * 3001] = 3;
		val[i__ + j * 3001] = v;
	    }
	}
    }
    *score0 = val[dpc_1.nseq1 + dpc_1.nseq2 * 3001];
    i__1 = dpc_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	dpc_1.j2i[j - 1] = -1;
    }
    i__ = dpc_1.nseq1;
    j = dpc_1.nseq2;
    while(i__ > 0 && j > 0) {
	if (idir[i__ + j * 3001] == 1) {
	    dpc_1.j2i[j - 1] = i__;
	    --i__;
	    --j;
	} else if (idir[i__ + j * 3001] == 2) {
	    i__1 = jph[i__ + j * 3001];
	    for (me = 1; me <= i__1; ++me) {
		if (i__ > 0) {
		    --i__;
		}
	    }
	} else {
	    i__1 = jpv[i__ + j * 3001];
	    for (me = 1; me <= i__1; ++me) {
		if (j > 0) {
		    --j;
		}
	    }
	}
    }
    return 0;
} /* dp2_ */

/* Subroutine */ int matrix_(void)
{
 matra_1.imut[0] = 4; matra_1.imut[23] = -1; matra_1.imut[46] = -2; matra_1.imut[69] = -2; matra_1.imut[92] = 0; matra_1.imut[115] = -1; matra_1.imut[138] = -1; matra_1.imut[161] = 0; matra_1.imut[184] = -2; matra_1.imut[207] = -1; matra_1.imut[230] = -1; matra_1.imut[253] = -1; matra_1.imut[276] = -1; matra_1.imut[299] = -2; matra_1.imut[322] = -1; matra_1.imut[345] = 1; matra_1.imut[368] = 0; matra_1.imut[391] = -3; matra_1.imut[414] = -2; matra_1.imut[437] = 0; matra_1.imut[460] = -2; matra_1.imut[483] = -1; matra_1.imut[506] = 0;
 matra_1.imut[1] = -1; matra_1.imut[24] = 5; matra_1.imut[47] = 0; matra_1.imut[70] = -2; matra_1.imut[93] = -3; matra_1.imut[116] = 1; matra_1.imut[139] = 0; matra_1.imut[162] = -2; matra_1.imut[185] = 0; matra_1.imut[208] = -3; matra_1.imut[231] = -2; matra_1.imut[254] = 2; matra_1.imut[277] = -1; matra_1.imut[300] = -3; matra_1.imut[323] = -2; matra_1.imut[346] = -1; matra_1.imut[369] = -1; matra_1.imut[392] = -3; matra_1.imut[415] = -2; matra_1.imut[438] = -3; matra_1.imut[461] = -1; matra_1.imut[484] = 0; matra_1.imut[507] = -1;
 matra_1.imut[2] = -2; matra_1.imut[25] = 0; matra_1.imut[48] = 6; matra_1.imut[71] = 1; matra_1.imut[94] = -3; matra_1.imut[117] = 0; matra_1.imut[140] = 0; matra_1.imut[163] = 0; matra_1.imut[186] = 1; matra_1.imut[209] = -3; matra_1.imut[232] = -3; matra_1.imut[255] = 0; matra_1.imut[278] = -2; matra_1.imut[301] = -3; matra_1.imut[324] = -2; matra_1.imut[347] = 1; matra_1.imut[370] = 0; matra_1.imut[393] = -4; matra_1.imut[416] = -2; matra_1.imut[439] = -3; matra_1.imut[462] = 3; matra_1.imut[485] = 0; matra_1.imut[508] = -1;
 matra_1.imut[3] = -2; matra_1.imut[26] = -2; matra_1.imut[49] = 1; matra_1.imut[72] = 6; matra_1.imut[95] = -3; matra_1.imut[118] = 0; matra_1.imut[141] = 2; matra_1.imut[164] = -1; matra_1.imut[187] = -1; matra_1.imut[210] = -3; matra_1.imut[233] = -4; matra_1.imut[256] = -1; matra_1.imut[279] = -3; matra_1.imut[302] = -3; matra_1.imut[325] = -1; matra_1.imut[348] = 0; matra_1.imut[371] = -1; matra_1.imut[394] = -4; matra_1.imut[417] = -3; matra_1.imut[440] = -3; matra_1.imut[463] = 4; matra_1.imut[486] = 1; matra_1.imut[509] = -1;
 matra_1.imut[4] = 0; matra_1.imut[27] = -3; matra_1.imut[50] = -3; matra_1.imut[73] = -3; matra_1.imut[96] = 9; matra_1.imut[119] = -3; matra_1.imut[142] = -4; matra_1.imut[165] = -3; matra_1.imut[188] = -3; matra_1.imut[211] = -1; matra_1.imut[234] = -1; matra_1.imut[257] = -3; matra_1.imut[280] = -1; matra_1.imut[303] = -2; matra_1.imut[326] = -3; matra_1.imut[349] = -1; matra_1.imut[372] = -1; matra_1.imut[395] = -2; matra_1.imut[418] = -2; matra_1.imut[441] = -1; matra_1.imut[464] = -3; matra_1.imut[487] = -3; matra_1.imut[510] = -2;
 matra_1.imut[5] = -1; matra_1.imut[28] = 1; matra_1.imut[51] = 0; matra_1.imut[74] = 0; matra_1.imut[97] = -3; matra_1.imut[120] = 5; matra_1.imut[143] = 2; matra_1.imut[166] = -2; matra_1.imut[189] = 0; matra_1.imut[212] = -3; matra_1.imut[235] = -2; matra_1.imut[258] = 1; matra_1.imut[281] = 0; matra_1.imut[304] = -3; matra_1.imut[327] = -1; matra_1.imut[350] = 0; matra_1.imut[373] = -1; matra_1.imut[396] = -2; matra_1.imut[419] = -1; matra_1.imut[442] = -2; matra_1.imut[465] = 0; matra_1.imut[488] = 3; matra_1.imut[511] = -1;
 matra_1.imut[6] = -1; matra_1.imut[29] = 0; matra_1.imut[52] = 0; matra_1.imut[75] = 2; matra_1.imut[98] = -4; matra_1.imut[121] = 2; matra_1.imut[144] = 5; matra_1.imut[167] = -2; matra_1.imut[190] = 0; matra_1.imut[213] = -3; matra_1.imut[236] = -3; matra_1.imut[259] = 1; matra_1.imut[282] = -2; matra_1.imut[305] = -3; matra_1.imut[328] = -1; matra_1.imut[351] = 0; matra_1.imut[374] = -1; matra_1.imut[397] = -3; matra_1.imut[420] = -2; matra_1.imut[443] = -2; matra_1.imut[466] = 1; matra_1.imut[489] = 4; matra_1.imut[512] = -1;
 matra_1.imut[7] = 0; matra_1.imut[30] = -2; matra_1.imut[53] = 0; matra_1.imut[76] = -1; matra_1.imut[99] = -3; matra_1.imut[122] = -2; matra_1.imut[145] = -2; matra_1.imut[168] = 6; matra_1.imut[191] = -2; matra_1.imut[214] = -4; matra_1.imut[237] = -4; matra_1.imut[260] = -2; matra_1.imut[283] = -3; matra_1.imut[306] = -3; matra_1.imut[329] = -2; matra_1.imut[352] = 0; matra_1.imut[375] = -2; matra_1.imut[398] = -2; matra_1.imut[421] = -3; matra_1.imut[444] = -3; matra_1.imut[467] = -1; matra_1.imut[490] = -2; matra_1.imut[513] = -1;
 matra_1.imut[8] = -2; matra_1.imut[31] = 0; matra_1.imut[54] = 1; matra_1.imut[77] = -1; matra_1.imut[100] = -3; matra_1.imut[123] = 0; matra_1.imut[146] = 0; matra_1.imut[169] = -2; matra_1.imut[192] = 8; matra_1.imut[215] = -3; matra_1.imut[238] = -3; matra_1.imut[261] = -1; matra_1.imut[284] = -2; matra_1.imut[307] = -1; matra_1.imut[330] = -2; matra_1.imut[353] = -1; matra_1.imut[376] = -2; matra_1.imut[399] = -2; matra_1.imut[422] = 2; matra_1.imut[445] = -3; matra_1.imut[468] = 0; matra_1.imut[491] = 0; matra_1.imut[514] = -1;
 matra_1.imut[9] = -1; matra_1.imut[32] = -3; matra_1.imut[55] = -3; matra_1.imut[78] = -3; matra_1.imut[101] = -1; matra_1.imut[124] = -3; matra_1.imut[147] = -3; matra_1.imut[170] = -4; matra_1.imut[193] = -3; matra_1.imut[216] = 4; matra_1.imut[239] = 2; matra_1.imut[262] = -3; matra_1.imut[285] = 1; matra_1.imut[308] = 0; matra_1.imut[331] = -3; matra_1.imut[354] = -2; matra_1.imut[377] = -1; matra_1.imut[400] = -3; matra_1.imut[423] = -1; matra_1.imut[446] = 3; matra_1.imut[469] = -3; matra_1.imut[492] = -3; matra_1.imut[515] = -1;
 matra_1.imut[10] = -1; matra_1.imut[33] = -2; matra_1.imut[56] = -3; matra_1.imut[79] = -4; matra_1.imut[102] = -1; matra_1.imut[125] = -2; matra_1.imut[148] = -3; matra_1.imut[171] = -4; matra_1.imut[194] = -3; matra_1.imut[217] = 2; matra_1.imut[240] = 4; matra_1.imut[263] = -2; matra_1.imut[286] = 2; matra_1.imut[309] = 0; matra_1.imut[332] = -3; matra_1.imut[355] = -2; matra_1.imut[378] = -1; matra_1.imut[401] = -2; matra_1.imut[424] = -1; matra_1.imut[447] = 1; matra_1.imut[470] = -4; matra_1.imut[493] = -3; matra_1.imut[516] = -1;
 matra_1.imut[11] = -1; matra_1.imut[34] = 2; matra_1.imut[57] = 0; matra_1.imut[80] = -1; matra_1.imut[103] = -3; matra_1.imut[126] = 1; matra_1.imut[149] = 1; matra_1.imut[172] = -2; matra_1.imut[195] = -1; matra_1.imut[218] = -3; matra_1.imut[241] = -2; matra_1.imut[264] = 5; matra_1.imut[287] = -1; matra_1.imut[310] = -3; matra_1.imut[333] = -1; matra_1.imut[356] = 0; matra_1.imut[379] = -1; matra_1.imut[402] = -3; matra_1.imut[425] = -2; matra_1.imut[448] = -2; matra_1.imut[471] = 0; matra_1.imut[494] = 1; matra_1.imut[517] = -1;
 matra_1.imut[12] = -1; matra_1.imut[35] = -1; matra_1.imut[58] = -2; matra_1.imut[81] = -3; matra_1.imut[104] = -1; matra_1.imut[127] = 0; matra_1.imut[150] = -2; matra_1.imut[173] = -3; matra_1.imut[196] = -2; matra_1.imut[219] = 1; matra_1.imut[242] = 2; matra_1.imut[265] = -1; matra_1.imut[288] = 5; matra_1.imut[311] = 0; matra_1.imut[334] = -2; matra_1.imut[357] = -1; matra_1.imut[380] = -1; matra_1.imut[403] = -1; matra_1.imut[426] = -1; matra_1.imut[449] = 1; matra_1.imut[472] = -3; matra_1.imut[495] = -1; matra_1.imut[518] = -1;
 matra_1.imut[13] = -2; matra_1.imut[36] = -3; matra_1.imut[59] = -3; matra_1.imut[82] = -3; matra_1.imut[105] = -2; matra_1.imut[128] = -3; matra_1.imut[151] = -3; matra_1.imut[174] = -3; matra_1.imut[197] = -1; matra_1.imut[220] = 0; matra_1.imut[243] = 0; matra_1.imut[266] = -3; matra_1.imut[289] = 0; matra_1.imut[312] = 6; matra_1.imut[335] = -4; matra_1.imut[358] = -2; matra_1.imut[381] = -2; matra_1.imut[404] = 1; matra_1.imut[427] = 3; matra_1.imut[450] = -1; matra_1.imut[473] = -3; matra_1.imut[496] = -3; matra_1.imut[519] = -1;
 matra_1.imut[14] = -1; matra_1.imut[37] = -2; matra_1.imut[60] = -2; matra_1.imut[83] = -1; matra_1.imut[106] = -3; matra_1.imut[129] = -1; matra_1.imut[152] = -1; matra_1.imut[175] = -2; matra_1.imut[198] = -2; matra_1.imut[221] = -3; matra_1.imut[244] = -3; matra_1.imut[267] = -1; matra_1.imut[290] = -2; matra_1.imut[313] = -4; matra_1.imut[336] = 7; matra_1.imut[359] = -1; matra_1.imut[382] = -1; matra_1.imut[405] = -4; matra_1.imut[428] = -3; matra_1.imut[451] = -2; matra_1.imut[474] = -2; matra_1.imut[497] = -1; matra_1.imut[520] = -2;
 matra_1.imut[15] = 1; matra_1.imut[38] = -1; matra_1.imut[61] = 1; matra_1.imut[84] = 0; matra_1.imut[107] = -1; matra_1.imut[130] = 0; matra_1.imut[153] = 0; matra_1.imut[176] = 0; matra_1.imut[199] = -1; matra_1.imut[222] = -2; matra_1.imut[245] = -2; matra_1.imut[268] = 0; matra_1.imut[291] = -1; matra_1.imut[314] = -2; matra_1.imut[337] = -1; matra_1.imut[360] = 4; matra_1.imut[383] = 1; matra_1.imut[406] = -3; matra_1.imut[429] = -2; matra_1.imut[452] = -2; matra_1.imut[475] = 0; matra_1.imut[498] = 0; matra_1.imut[521] = 0;
 matra_1.imut[16] = 0; matra_1.imut[39] = -1; matra_1.imut[62] = 0; matra_1.imut[85] = -1; matra_1.imut[108] = -1; matra_1.imut[131] = -1; matra_1.imut[154] = -1; matra_1.imut[177] = -2; matra_1.imut[200] = -2; matra_1.imut[223] = -1; matra_1.imut[246] = -1; matra_1.imut[269] = -1; matra_1.imut[292] = -1; matra_1.imut[315] = -2; matra_1.imut[338] = -1; matra_1.imut[361] = 1; matra_1.imut[384] = 5; matra_1.imut[407] = -2; matra_1.imut[430] = -2; matra_1.imut[453] = 0; matra_1.imut[476] = -1; matra_1.imut[499] = -1; matra_1.imut[522] = 0;
 matra_1.imut[17] = -3; matra_1.imut[40] = -3; matra_1.imut[63] = -4; matra_1.imut[86] = -4; matra_1.imut[109] = -2; matra_1.imut[132] = -2; matra_1.imut[155] = -3; matra_1.imut[178] = -2; matra_1.imut[201] = -2; matra_1.imut[224] = -3; matra_1.imut[247] = -2; matra_1.imut[270] = -3; matra_1.imut[293] = -1; matra_1.imut[316] = 1; matra_1.imut[339] = -4; matra_1.imut[362] = -3; matra_1.imut[385] = -2; matra_1.imut[408] = 11; matra_1.imut[431] = 2; matra_1.imut[454] = -3; matra_1.imut[477] = -4; matra_1.imut[500] = -3; matra_1.imut[523] = -2;
 matra_1.imut[18] = -2; matra_1.imut[41] = -2; matra_1.imut[64] = -2; matra_1.imut[87] = -3; matra_1.imut[110] = -2; matra_1.imut[133] = -1; matra_1.imut[156] = -2; matra_1.imut[179] = -3; matra_1.imut[202] = 2; matra_1.imut[225] = -1; matra_1.imut[248] = -1; matra_1.imut[271] = -2; matra_1.imut[294] = -1; matra_1.imut[317] = 3; matra_1.imut[340] = -3; matra_1.imut[363] = -2; matra_1.imut[386] = -2; matra_1.imut[409] = 2; matra_1.imut[432] = 7; matra_1.imut[455] = -1; matra_1.imut[478] = -3; matra_1.imut[501] = -2; matra_1.imut[524] = -1;
 matra_1.imut[19] = 0; matra_1.imut[42] = -3; matra_1.imut[65] = -3; matra_1.imut[88] = -3; matra_1.imut[111] = -1; matra_1.imut[134] = -2; matra_1.imut[157] = -2; matra_1.imut[180] = -3; matra_1.imut[203] = -3; matra_1.imut[226] = 3; matra_1.imut[249] = 1; matra_1.imut[272] = -2; matra_1.imut[295] = 1; matra_1.imut[318] = -1; matra_1.imut[341] = -2; matra_1.imut[364] = -2; matra_1.imut[387] = 0; matra_1.imut[410] = -3; matra_1.imut[433] = -1; matra_1.imut[456] = 4; matra_1.imut[479] = -3; matra_1.imut[502] = -2; matra_1.imut[525] = -1;
 matra_1.imut[20] = -2; matra_1.imut[43] = -1; matra_1.imut[66] = 3; matra_1.imut[89] = 4; matra_1.imut[112] = -3; matra_1.imut[135] = 0; matra_1.imut[158] = 1; matra_1.imut[181] = -1; matra_1.imut[204] = 0; matra_1.imut[227] = -3; matra_1.imut[250] = -4; matra_1.imut[273] = 0; matra_1.imut[296] = -3; matra_1.imut[319] = -3; matra_1.imut[342] = -2; matra_1.imut[365] = 0; matra_1.imut[388] = -1; matra_1.imut[411] = -4; matra_1.imut[434] = -3; matra_1.imut[457] = -3; matra_1.imut[480] = 4; matra_1.imut[503] = 1; matra_1.imut[526] = -1;
 matra_1.imut[21] = -1; matra_1.imut[44] = 0; matra_1.imut[67] = 0; matra_1.imut[90] = 1; matra_1.imut[113] = -3; matra_1.imut[136] = 3; matra_1.imut[159] = 4; matra_1.imut[182] = -2; matra_1.imut[205] = 0; matra_1.imut[228] = -3; matra_1.imut[251] = -3; matra_1.imut[274] = 1; matra_1.imut[297] = -1; matra_1.imut[320] = -3; matra_1.imut[343] = -1; matra_1.imut[366] = 0; matra_1.imut[389] = -1; matra_1.imut[412] = -3; matra_1.imut[435] = -2; matra_1.imut[458] = -2; matra_1.imut[481] = 1; matra_1.imut[504] = 4; matra_1.imut[527] = -1;
 matra_1.imut[22] = 0; matra_1.imut[45] = -1; matra_1.imut[68] = -1; matra_1.imut[91] = -1; matra_1.imut[114] = -2; matra_1.imut[137] = -1; matra_1.imut[160] = -1; matra_1.imut[183] = -1; matra_1.imut[206] = -1; matra_1.imut[229] = -1; matra_1.imut[252] = -1; matra_1.imut[275] = -1; matra_1.imut[298] = -1; matra_1.imut[321] = -1; matra_1.imut[344] = -2; matra_1.imut[367] = 0; matra_1.imut[390] = 0; matra_1.imut[413] = -2; matra_1.imut[436] = -1; matra_1.imut[459] = -1; matra_1.imut[482] = -1; matra_1.imut[505] = -1; matra_1.imut[528] = -1;
 
 return 0;
} /* matrix_ */

/* Main program alias */ int nwalign_ ( double *nw_score1a, double *nw_score1b, int nw_len1a, int nw_len1b, char nw_seq1a[], char nw_seq1b[], int nw_ali1[] )
{ 
 int nw_seq2a[MAXPRO];
 int nw_seq2b[MAXPRO];
 
 int nw_ali2[MAXPRO];
 
 for ( int i3 = 0; i3 < nw_len1a; i3++ )
  switch (nw_seq1a[i3])
  {
   case 'A' : nw_seq2a[i3] =  1; break;
   case 'R' : nw_seq2a[i3] =  2; break;
   case 'N' : nw_seq2a[i3] =  3; break;
   case 'D' : nw_seq2a[i3] =  4; break;
   case 'C' : nw_seq2a[i3] =  5; break;
   case 'Q' : nw_seq2a[i3] =  6; break;
   case 'E' : nw_seq2a[i3] =  7; break;
   case 'G' : nw_seq2a[i3] =  8; break;
   case 'H' : nw_seq2a[i3] =  9; break;
   case 'I' : nw_seq2a[i3] = 10; break;
   case 'L' : nw_seq2a[i3] = 11; break;
   case 'K' : nw_seq2a[i3] = 12; break;
   case 'M' : nw_seq2a[i3] = 13; break;
   case 'F' : nw_seq2a[i3] = 14; break;
   case 'P' : nw_seq2a[i3] = 15; break;
   case 'S' : nw_seq2a[i3] = 16; break;
   case 'T' : nw_seq2a[i3] = 17; break;
   case 'W' : nw_seq2a[i3] = 18; break;
   case 'Y' : nw_seq2a[i3] = 19; break;
   case 'V' : nw_seq2a[i3] = 20; break;
   case 'B' : nw_seq2a[i3] = 21; break;
   case 'Z' : nw_seq2a[i3] = 22; break;
   case 'X' : nw_seq2a[i3] = 23; break;
  }
 
 for ( int i3 = 0; i3 < nw_len1b; i3++ )
  switch (nw_seq1b[i3])
  {
   case 'A' : nw_seq2b[i3] =  1; break;
   case 'R' : nw_seq2b[i3] =  2; break;
   case 'N' : nw_seq2b[i3] =  3; break;
   case 'D' : nw_seq2b[i3] =  4; break;
   case 'C' : nw_seq2b[i3] =  5; break;
   case 'Q' : nw_seq2b[i3] =  6; break;
   case 'E' : nw_seq2b[i3] =  7; break;
   case 'G' : nw_seq2b[i3] =  8; break;
   case 'H' : nw_seq2b[i3] =  9; break;
   case 'I' : nw_seq2b[i3] = 10; break;
   case 'L' : nw_seq2b[i3] = 11; break;
   case 'K' : nw_seq2b[i3] = 12; break;
   case 'M' : nw_seq2b[i3] = 13; break;
   case 'F' : nw_seq2b[i3] = 14; break;
   case 'P' : nw_seq2b[i3] = 15; break;
   case 'S' : nw_seq2b[i3] = 16; break;
   case 'T' : nw_seq2b[i3] = 17; break;
   case 'W' : nw_seq2b[i3] = 18; break;
   case 'Y' : nw_seq2b[i3] = 19; break;
   case 'V' : nw_seq2b[i3] = 20; break;
   case 'B' : nw_seq2b[i3] = 21; break;
   case 'Z' : nw_seq2b[i3] = 22; break;
   case 'X' : nw_seq2b[i3] = 23; break;
  }
 
 MAIN_NW__ ( &(*nw_score1a), &(*nw_score1b), nw_len1a, nw_len1b, nw_seq2a, nw_seq2b, nw_ali2 );
 
 for ( int i3 = 0; i3 < nw_len1b; i3++ )
  nw_ali1[i3] = nw_ali2[i3];
 
 return 0;
}

#ifdef __cplusplus
	}
#endif
