/*
===============================================================================
   ___________.___ _______  ________    _________._________________________
   \_   _____/|   |\      \ \______ \  /   _____/|   \__    ___/\_   _____/
    |    __)  |   |/   |   \ |    |  \ \_____  \ |   | |    |    |    __)_
    |     \   |   /    |    \|    `   \/        \|   | |    |    |        \
    \___  /   |___\____|__  /_______  /_______  /|___| |____|   /_______  /
        \/                \/        \/        \/                        \/
                                          __        __
                          ____ ___  ___  / /_____ _/ /
                         / __ `__ \/ _ \/ __/ __ `/ / 
                        / / / / / /  __/ /_/ /_/ / /  
                       /_/ /_/ /_/\___/\__/\__,_/_/   

   FINDSITE-METAL predicts metal-binding sites, residues and metal preferences
   from template structures identified by threading

   Make sure you have libf2c, gzstream, zlib and libsvm installed

   This software is distributed WITHOUT ANY WARRANTY

   Please report bugs to michal@gatech.edu

   Center for the Study of Systems Biology
   250 14th Street NW, Atlanta, GA 30318, USA
===============================================================================
*/

/* frtmalign.f -- translated by f2c (version 20061008).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#ifdef __cplusplus
extern "C" {
#endif
#include "f2c.h"
#include "frtmalign.h"

/* Common Block Declarations */

struct {
    real xa[18000]	/* was [3][3000][2] */;
} coord_;

#define coord_1 coord_

struct {
    integer nseq1, nseq2;
} length_;

#define length_1 length_

struct {
    integer ires1[1800000]	/* was [3000][600] */;
    char resa[5400000]	/* was [3000][600] */, seqa[1800000]	/* was [3000][
	    600] */;
} pdbinfo_;

#define pdbinfo_1 pdbinfo_

struct {
    integer isec[3000], jsec[3000];
} secstr_;

#define secstr_1 secstr_

struct {
    integer n1[3000], n2[3000];
} n1n2_;

#define n1n2_1 n1n2_

struct {
    real d8;
} dinfo_;

#define dinfo_1 dinfo_

struct {
    real xt[3000], yt[3000], zt[3000], xb[3000], yb[3000], zb[3000];
} stru_;

#define stru_1 stru_

struct {
    integer ia[3000], ib[3000];
} align_;

#define align_1 align_

/* Table of constant values */

static doublereal c_b182 = .3;
static doublereal c_b183 = .33333333333333331;
static integer c__1 = 1;
static integer c__9 = 9;
static integer c__3 = 3;
static integer c__4 = 4;
static integer c__0 = 0;
static integer c__2 = 2;
static integer c__12 = 12;
static integer c__7 = 7;
static integer c__6 = 6;
static integer c__14 = 14;

/* Main program */ int MAIN_FR__( int *aln3_length, double *aln3_rmsd, double *aln3_tmscore, double *aln3_identity, int length3a, int length3b, double tt3[], double uu3[][3], double xyz3a[], double xyz3b[], char seqa3a[], char seqa3b[], int ires3a[], int ires3b[], int align3[][2], int length3c )
{
    /* Initialized data */

    static doublereal w[3000] = { 1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1. };

    /* Format strings */
    static char fmt_108[] = "(2a7,\002= Aligned length=\002,i4,\002, RMSD\
=\002,f6.2,\002, TM-score=\002,f7.5,\002, ID=\002,f5.3)";
    static char fmt_204[] = "(i2,f18.10,f15.10,f15.10,f15.10)";
    static char fmt_900[] = "(a)";
    static char fmt_901[] = "(\002select atomno=\002,i4)";
    static char fmt_102[] = "(\002REMARK   Protein 1:\002,a10,\002 Length \
=\002,i4)";
    static char fmt_103[] = "(\002REMARK   Protein 2:\002,a10,\002 Length \
=\002,i4)";
    static char fmt_104[] = "(\002REMARK   Structural alignment summary: \
\002,\002 Aligned length=\002,i4,\002; RMSD =\002,f6.2,\002; TM-score=\002,f\
7.5)";
    static char fmt_1237[] = "(\002ATOM  \002,i5,\002  CA  \002,a3,i6,4x,3f8\
.3)";
    static char fmt_1238[] = "(\002TER\002)";
    static char fmt_1239[] = "(\002CONECT\002,i5,i5)";

    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2, r__3;
    doublereal d__1;
    olist o__1;
    cllist cl__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);
    double pow_dd(doublereal *, doublereal *), sqrt(doublereal);
    integer s_wsfe(cilist *), do_fio(integer *, char *, ftnlen), e_wsfe(), 
	    f_open(olist *), s_wsle(cilist *), do_lio(integer *, integer *, 
	    char *, ftnlen), e_wsle(), f_clos(cllist *);
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    static real d0_input__;
    extern /* Subroutine */ int tmsearch_(real *, real *, integer *, real *, 
	    real *, real *, integer *, integer *, real *, real *, real *, 
	    integer *, real *, real *, integer *, integer *);
    static real d0_search__;
    static integer i__, j, k, l;
    static doublereal t[3], u[9]	/* was [3][3] */;
    static real d0;
    static integer m1[3000], m2[3000], irun_type__, ii, ik, jj, no;
    static real tm;
    static doublereal r_1__[9000]	/* was [3][3000] */, r_2__[9000]	
	    /* was [3][3000] */;
    extern /* Subroutine */ int u3b_(doublereal *, doublereal *, doublereal *,
	     integer *, integer *, doublereal *, doublereal *, doublereal *, 
	    integer *);
    static real tm8;
    static char pdb[100*2];
    static integer ier;
    static doublereal rms;
    static real xyz[5400000]	/* was [3][3000][600] */, dis2;
    extern /* Subroutine */ int super_align__(real *, real *, integer *, 
	    integer *);
    static real xtm1[3000], ytm1[3000], ztm1[3000], xtm2[3000], ytm2[3000], 
	    ztm2[3000];
    static integer n_al__, ipdb, n_eq__;
    static char pdbn[100*600];
    static integer mmat, ires[6000]	/* was [3000][2] */, mfix;
    static char seqn[1*3000*2], resn[3*3000*2];
    static integer nseq, mout, n8_al__;
    static char aseq1[1*6000], aseq2[1*6000], aseq3[1*6000];
    static integer l_fix__, nopdb, lcomm;
    static real anseq, rcomm;
    static integer ilist;
    static real d0_min__;
    static integer i1_old__, i2_old__;
    static real seq_id__;
    static integer length[600], invmap0[3000], isearch;
    static real aminlen;
    static char outname[100];
    static real rmsd8_al__;

    /* Fortran I/O blocks */
    static cilist io___50 = { 0, 6, 0, fmt_108, 0 };
    static cilist io___58 = { 0, 8, 0, 0, 0 };
    static cilist io___59 = { 0, 8, 0, 0, 0 };
    static cilist io___60 = { 0, 8, 0, fmt_204, 0 };
    static cilist io___66 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___67 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___68 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___69 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___70 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___71 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___72 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___73 = { 0, 9, 0, fmt_901, 0 };
    static cilist io___74 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___75 = { 0, 9, 0, fmt_901, 0 };
    static cilist io___76 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___77 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___78 = { 0, 9, 0, fmt_900, 0 };
    static cilist io___79 = { 0, 9, 0, fmt_102, 0 };
    static cilist io___80 = { 0, 9, 0, fmt_103, 0 };
    static cilist io___81 = { 0, 9, 0, fmt_104, 0 };
    static cilist io___82 = { 0, 9, 0, fmt_1237, 0 };
    static cilist io___83 = { 0, 9, 0, fmt_1238, 0 };
    static cilist io___84 = { 0, 9, 0, fmt_1239, 0 };
    static cilist io___85 = { 0, 9, 0, fmt_1237, 0 };
    static cilist io___86 = { 0, 9, 0, fmt_1238, 0 };
    static cilist io___87 = { 0, 9, 0, fmt_1239, 0 };


/* no. of residues */
/* for alignment */
/* no. of proteins to align */
/* cc   RMSD: */
/* armsd is real */
/* secondary structure */
    mout = -1;
/* output file */
    mfix = -1;
/* Fixed length TM-score */
    mmat = 0;
/* Transformatrix output */
    no = 1;
/* Number of pdbs */
    irun_type__ = 0;
/* 0 is slow version */
/* 1 is fast version */
/* TYPE of Algorithm used for Fragment alignment */
    ilist = 0;
    nopdb = 2;
/* c INPUT DATA START */
    
    length[0] = length3a;
    length[1] = length3b;
    
    for ( int ii3 = 0; ii3 < length[0] * 3; ii3++ )
     xyz[ii3] = xyz3a[ii3];
    
    for ( int ii3 = 0; ii3 < length[1] * 3; ii3++ )
     xyz[ii3+9000] = xyz3b[ii3];
    
    for ( int ii3 = 0; ii3 < length[0]; ii3++ )
    {
     *(unsigned char *)&pdbinfo_1.seqa[ii3] = seqa3a[ii3];
     
     switch (seqa3a[ii3])
     {
      case 'A' : s_copy(pdbinfo_1.resa + ii3 * 3, "ALA", (ftnlen)3, (ftnlen)3); break;
      case 'C' : s_copy(pdbinfo_1.resa + ii3 * 3, "CYS", (ftnlen)3, (ftnlen)3); break;
      case 'D' : s_copy(pdbinfo_1.resa + ii3 * 3, "ASP", (ftnlen)3, (ftnlen)3); break;
      case 'E' : s_copy(pdbinfo_1.resa + ii3 * 3, "GLU", (ftnlen)3, (ftnlen)3); break;
      case 'F' : s_copy(pdbinfo_1.resa + ii3 * 3, "PHE", (ftnlen)3, (ftnlen)3); break;
      case 'G' : s_copy(pdbinfo_1.resa + ii3 * 3, "GLY", (ftnlen)3, (ftnlen)3); break;
      case 'H' : s_copy(pdbinfo_1.resa + ii3 * 3, "HIS", (ftnlen)3, (ftnlen)3); break;
      case 'I' : s_copy(pdbinfo_1.resa + ii3 * 3, "ILE", (ftnlen)3, (ftnlen)3); break;
      case 'K' : s_copy(pdbinfo_1.resa + ii3 * 3, "LYS", (ftnlen)3, (ftnlen)3); break;
      case 'L' : s_copy(pdbinfo_1.resa + ii3 * 3, "LEU", (ftnlen)3, (ftnlen)3); break;
      case 'M' : s_copy(pdbinfo_1.resa + ii3 * 3, "MET", (ftnlen)3, (ftnlen)3); break;
      case 'N' : s_copy(pdbinfo_1.resa + ii3 * 3, "ASN", (ftnlen)3, (ftnlen)3); break;
      case 'P' : s_copy(pdbinfo_1.resa + ii3 * 3, "PRO", (ftnlen)3, (ftnlen)3); break;
      case 'Q' : s_copy(pdbinfo_1.resa + ii3 * 3, "GLN", (ftnlen)3, (ftnlen)3); break;
      case 'R' : s_copy(pdbinfo_1.resa + ii3 * 3, "ARG", (ftnlen)3, (ftnlen)3); break;
      case 'S' : s_copy(pdbinfo_1.resa + ii3 * 3, "SER", (ftnlen)3, (ftnlen)3); break;
      case 'T' : s_copy(pdbinfo_1.resa + ii3 * 3, "THR", (ftnlen)3, (ftnlen)3); break;
      case 'V' : s_copy(pdbinfo_1.resa + ii3 * 3, "VAL", (ftnlen)3, (ftnlen)3); break;
      case 'W' : s_copy(pdbinfo_1.resa + ii3 * 3, "TRP", (ftnlen)3, (ftnlen)3); break;
      case 'Y' : s_copy(pdbinfo_1.resa + ii3 * 3, "TYR", (ftnlen)3, (ftnlen)3); break;
     }
    }
    
    for ( int ii3 = 0; ii3 < length[1]; ii3++ )
    {
     *(unsigned char *)&pdbinfo_1.seqa[ii3+3000] = seqa3b[ii3];
     
     switch (seqa3b[ii3])
     {
      case 'A' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "ALA", (ftnlen)3, (ftnlen)3); break;
      case 'C' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "CYS", (ftnlen)3, (ftnlen)3); break;
      case 'D' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "ASP", (ftnlen)3, (ftnlen)3); break;
      case 'E' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "GLU", (ftnlen)3, (ftnlen)3); break;
      case 'F' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "PHE", (ftnlen)3, (ftnlen)3); break;
      case 'G' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "GLY", (ftnlen)3, (ftnlen)3); break;
      case 'H' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "HIS", (ftnlen)3, (ftnlen)3); break;
      case 'I' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "ILE", (ftnlen)3, (ftnlen)3); break;
      case 'K' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "LYS", (ftnlen)3, (ftnlen)3); break;
      case 'L' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "LEU", (ftnlen)3, (ftnlen)3); break;
      case 'M' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "MET", (ftnlen)3, (ftnlen)3); break;
      case 'N' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "ASN", (ftnlen)3, (ftnlen)3); break;
      case 'P' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "PRO", (ftnlen)3, (ftnlen)3); break;
      case 'Q' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "GLN", (ftnlen)3, (ftnlen)3); break;
      case 'R' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "ARG", (ftnlen)3, (ftnlen)3); break;
      case 'S' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "SER", (ftnlen)3, (ftnlen)3); break;
      case 'T' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "THR", (ftnlen)3, (ftnlen)3); break;
      case 'V' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "VAL", (ftnlen)3, (ftnlen)3); break;
      case 'W' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "TRP", (ftnlen)3, (ftnlen)3); break;
      case 'Y' : s_copy(pdbinfo_1.resa + ii3 * 3 + 9000, "TYR", (ftnlen)3, (ftnlen)3); break;
     }
    }
    
    for ( int ii3 = 0; ii3 < length[0]; ii3++ )
     pdbinfo_1.ires1[ii3] = ires3a[ii3];
    
    for ( int ii3 = 0; ii3 < length[1]; ii3++ )
     pdbinfo_1.ires1[ii3+3000] = ires3b[ii3];
    
/* c INPUT DATA END */
    for (i__ = 0; i__ <= 1; ++i__) {
	ik = i__ + 1;
	i__1 = length[ik - 1];
	for (j = 1; j <= i__1; ++j) {
	    for (k = 1; k <= 3; ++k) {
		coord_1.xa[k + (j + i__ * 3000) * 3 - 4] = xyz[k + (j + ik * 
			3000) * 3 - 9004];
	    }
	    *(unsigned char *)&seqn[j + i__ * 3000 - 1] = *(unsigned char *)&
		    pdbinfo_1.seqa[j + ik * 3000 - 3001];
	    s_copy(resn + (j + i__ * 3000 - 1) * 3, pdbinfo_1.resa + (j + ik *
		     3000 - 3001) * 3, (ftnlen)3, (ftnlen)3);
	    ires[j + i__ * 3000 - 1] = pdbinfo_1.ires1[j + ik * 3000 - 3001];
	}
    }
    length_1.nseq1 = length[0];
    length_1.nseq2 = length[1];
/* c initialize the coordinates xa() for superposition */
    i__1 = nopdb - 1;
    for (ipdb = 1; ipdb <= i__1; ++ipdb) {
/* main cycle */
	if (ilist == 1) {
	    i__ = 0;
	    i__2 = length[ipdb - 1];
	    for (j = 1; j <= i__2; ++j) {
		for (k = 1; k <= 3; ++k) {
		    coord_1.xa[k + (j + i__ * 3000) * 3 - 4] = xyz[k + (j + 
			    ipdb * 3000) * 3 - 9004];
		}
		*(unsigned char *)&seqn[j + i__ * 3000 - 1] = *(unsigned char 
			*)&pdbinfo_1.seqa[j + ipdb * 3000 - 3001];
		s_copy(resn + (j + i__ * 3000 - 1) * 3, pdbinfo_1.resa + (j + 
			ipdb * 3000 - 3001) * 3, (ftnlen)3, (ftnlen)3);
		ires[j + i__ * 3000 - 1] = pdbinfo_1.ires1[j + ipdb * 3000 - 
			3001];
	    }
	    if (ipdb == 1) {
/* read second protein only once !! */
		i__ = 1;
		jj = nopdb;
		i__2 = length[jj - 1];
		for (j = 1; j <= i__2; ++j) {
		    for (k = 1; k <= 3; ++k) {
			coord_1.xa[k + (j + i__ * 3000) * 3 - 4] = xyz[k + (j 
				+ jj * 3000) * 3 - 9004];
		    }
		    *(unsigned char *)&seqn[j + i__ * 3000 - 1] = *(unsigned 
			    char *)&pdbinfo_1.seqa[j + jj * 3000 - 3001];
		    s_copy(resn + (j + i__ * 3000 - 1) * 3, pdbinfo_1.resa + (
			    j + jj * 3000 - 3001) * 3, (ftnlen)3, (ftnlen)3);
		    ires[j + i__ * 3000 - 1] = pdbinfo_1.ires1[j + jj * 3000 
			    - 3001];
		}
		length_1.nseq2 = length[jj - 1];
		s_copy(pdb + 100, pdbn + (nopdb - 1) * 100, (ftnlen)100, (
			ftnlen)100);
	    }
	    length_1.nseq1 = length[ipdb - 1];
	    s_copy(pdb, pdbn + (ipdb - 1) * 100, (ftnlen)100, (ftnlen)100);
	} else {
	    for (i__ = 0; i__ <= 1; ++i__) {
		ik = i__ + 1;
		i__2 = length[ik - 1];
		for (j = 1; j <= i__2; ++j) {
		    for (k = 1; k <= 3; ++k) {
			coord_1.xa[k + (j + i__ * 3000) * 3 - 4] = xyz[k + (j 
				+ ik * 3000) * 3 - 9004];
		    }
		    *(unsigned char *)&seqn[j + i__ * 3000 - 1] = *(unsigned 
			    char *)&pdbinfo_1.seqa[j + ik * 3000 - 3001];
		    s_copy(resn + (j + i__ * 3000 - 1) * 3, pdbinfo_1.resa + (
			    j + ik * 3000 - 3001) * 3, (ftnlen)3, (ftnlen)3);
		    ires[j + i__ * 3000 - 1] = pdbinfo_1.ires1[j + ik * 3000 
			    - 3001];
		}
	    }
	    length_1.nseq1 = length[0];
	    length_1.nseq2 = length[1];
	}
/* c fixing d0 for search ONLY with d0 fixed for small protein */
	d0_min__ = (float).5;
	aminlen = (real) min(length_1.nseq1,length_1.nseq2);
	d__1 = (doublereal) aminlen;
	dinfo_1.d8 = pow_dd(&d__1, &c_b182) * (float)1.5 + (float)3.5;
/* remove pairs with dis>d8 during search */
	if (aminlen > (float)15.) {
	    d__1 = (doublereal) (aminlen - 15);
	    d0 = pow_dd(&d__1, &c_b183) * (float)1.24 - (float)1.8;
/* scale for defining TM-score */
	} else {
	    d0 = d0_min__;
	}
	nseq = max(length_1.nseq1,length_1.nseq2);
	i__2 = nseq;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    n1n2_1.n1[i__ - 1] = i__;
	    n1n2_1.n2[i__ - 1] = i__;
	}
	d0_search__ = d0;
	if (d0_search__ > (float)8.) {
	    d0_search__ = (float)8.;
	}
	if (d0_search__ < (float)3.) {
	    d0_search__ = (float)4.5;
	}
	super_align__(&d0, &d0_search__, invmap0, &irun_type__);
/* c resuperose to find residues d < d8 */
	if (d0_search__ < (float)4.5) {
	    d0_search__ = (float)4.5;
	}
	n_al__ = 0;
	i__2 = length_1.nseq2;
	for (j = 1; j <= i__2; ++j) {
	    if (invmap0[j - 1] > 0) {
		i__ = invmap0[j - 1];
		++n_al__;
		xtm1[n_al__ - 1] = coord_1.xa[i__ * 3 - 3];
		ytm1[n_al__ - 1] = coord_1.xa[i__ * 3 - 2];
		ztm1[n_al__ - 1] = coord_1.xa[i__ * 3 - 1];
		xtm2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 3];
		ytm2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 2];
		ztm2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 1];
		m1[n_al__ - 1] = i__;
/* for recording residue order */
		m2[n_al__ - 1] = j;
	    }
	}
	d0_input__ = d0;
	isearch = 2;
	tmsearch_(&d0_input__, &d0_search__, &n_al__, xtm1, ytm1, ztm1, 
		n1n2_1.n1, &n_al__, xtm2, ytm2, ztm2, n1n2_1.n2, &tm, &rcomm, 
		&lcomm, &isearch);
/* ccc for Output TM-score set d0 */
/* TM-score with dis<d8 only */
	d0_min__ = (float).5;
/* for output */
	/*anseq = (real) length_1.nseq2;*/
        anseq = (real) length3c;
/* length for defining final TMscore */
	if (mfix == 1) {
	    anseq = (real) l_fix__;
	}
/* input length */
	if (anseq > (float)15.) {
	    d__1 = (doublereal) (anseq - 15);
	    d0 = pow_dd(&d__1, &c_b183) * (float)1.24 - (float)1.8;
/* scale for defining TM-score */
	} else {
	    d0 = d0_min__;
	}
	if (d0 < d0_min__) {
	    d0 = d0_min__;
	}
	d0_search__ = d0;
	if (d0_search__ > (float)8.) {
	    d0_search__ = (float)8.;
	}
	if (d0_search__ < (float)4.5) {
	    d0_search__ = (float)4.5;
	}
/* ccc remove dis>d8 in normal TM-score calculation for final report */
	j = 0;
	n_eq__ = 0;
	i__2 = n_al__;
	for (i__ = 1; i__ <= i__2; ++i__) {
/* Computing 2nd power */
	    r__1 = xtm1[i__ - 1] - xtm2[i__ - 1];
/* Computing 2nd power */
	    r__2 = ytm1[i__ - 1] - ytm2[i__ - 1];
/* Computing 2nd power */
	    r__3 = ztm1[i__ - 1] - ztm2[i__ - 1];
	    dis2 = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
	    if (dis2 <= dinfo_1.d8) {
		++j;
		xtm1[j - 1] = xtm1[i__ - 1];
		ytm1[j - 1] = ytm1[i__ - 1];
		ztm1[j - 1] = ztm1[i__ - 1];
		xtm2[j - 1] = xtm2[i__ - 1];
		ytm2[j - 1] = ytm2[i__ - 1];
		ztm2[j - 1] = ztm2[i__ - 1];
		m1[j - 1] = m1[i__ - 1];
		m2[j - 1] = m2[i__ - 1];
		if (*(unsigned char *)&seqn[m1[i__ - 1] - 1] == *(unsigned 
			char *)&seqn[m2[i__ - 1] + 2999]) {
		    ++n_eq__;
		}
	    }
	}
	seq_id__ = (real) n_eq__ / (n_al__ + (float)1e-8);
	n8_al__ = j;
	d0_input__ = d0;
	isearch = 3;
	tmsearch_(&d0_input__, &d0_search__, &n8_al__, xtm1, ytm1, ztm1, 
		n1n2_1.n1, &n8_al__, xtm2, ytm2, ztm2, n1n2_1.n2, &tm8, &
		rcomm, &lcomm, &isearch);
/* normal TMscore */
	rmsd8_al__ = rcomm;
	tm8 /= anseq;
/* TM-score after cutoff */
	if (ilist == 1) {
	    s_wsfe(&io___50);
	    do_fio(&c__1, pdb, (ftnlen)5);
	    do_fio(&c__1, pdb + 100, (ftnlen)5);
	    do_fio(&c__1, (char *)&n8_al__, (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&rmsd8_al__, (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&tm8, (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&seq_id__, (ftnlen)sizeof(real));
	    e_wsfe();
	}
/* L1166: */
    }
/* ccc General output */
/* ccc Write rotation matrix */
    if (mmat == 1 && ilist == 0) {
	o__1.oerr = 0;
	o__1.ounit = 8;
	o__1.ofnmlen = 7;
	o__1.ofnm = "trf.mat";
	o__1.orl = 0;
	o__1.osta = "unknown";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	f_open(&o__1);
	l = 0;
	i__1 = n8_al__;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    k = m1[i__ - 1];
	    ++l;
	    r_1__[l * 3 - 3] = coord_1.xa[k * 3 - 3];
	    r_1__[l * 3 - 2] = coord_1.xa[k * 3 - 2];
	    r_1__[l * 3 - 1] = coord_1.xa[k * 3 - 1];
	    r_2__[l * 3 - 3] = xtm1[i__ - 1];
	    r_2__[l * 3 - 2] = ytm1[i__ - 1];
	    r_2__[l * 3 - 1] = ztm1[i__ - 1];
	}
	if (l > 3) {
	    u3b_(w, r_1__, r_2__, &l, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
	    s_wsle(&io___58);
	    do_lio(&c__9, &c__1, "Rotation matrix to rotate chain 1 to chain\
 2", (ftnlen)44);
	    e_wsle();
	    s_wsle(&io___59);
	    do_lio(&c__9, &c__1, "i          t(i)         u(i,1)         u(i\
,2) ", (ftnlen)46);
	    do_lio(&c__9, &c__1, "        u(i,3)", (ftnlen)14);
	    e_wsle();
	    for (i__ = 1; i__ <= 3; ++i__) {
		s_wsfe(&io___60);
		do_fio(&c__1, (char *)&i__, (ftnlen)sizeof(integer));
		do_fio(&c__1, (char *)&t[i__ - 1], (ftnlen)sizeof(doublereal))
			;
		do_fio(&c__1, (char *)&u[i__ - 1], (ftnlen)sizeof(doublereal))
			;
		do_fio(&c__1, (char *)&u[i__ + 2], (ftnlen)sizeof(doublereal))
			;
		do_fio(&c__1, (char *)&u[i__ + 5], (ftnlen)sizeof(doublereal))
			;
		e_wsfe();
	    }
	}
    }
    cl__1.cerr = 0;
    cl__1.cunit = 8;
    cl__1.csta = 0;
    f_clos(&cl__1);
    l = 0;
    i__1 = n8_al__;
    for (i__ = 1; i__ <= i__1; ++i__) {
	k = m1[i__ - 1];
	++l;
	r_1__[l * 3 - 3] = coord_1.xa[k * 3 - 3];
	r_1__[l * 3 - 2] = coord_1.xa[k * 3 - 2];
	r_1__[l * 3 - 1] = coord_1.xa[k * 3 - 1];
	r_2__[l * 3 - 3] = xtm1[i__ - 1];
	r_2__[l * 3 - 2] = ytm1[i__ - 1];
	r_2__[l * 3 - 1] = ztm1[i__ - 1];
    }
    if (l > 3) {
	u3b_(w, r_1__, r_2__, &l, &c__1, &rms, u, t, &ier);
        
        tt3[0] = t[0];
        tt3[1] = t[1];
        tt3[2] = t[2];
        
        uu3[0][0] = u[0]; uu3[0][1] = u[3]; uu3[0][2] = u[6];
        uu3[1][0] = u[1]; uu3[1][1] = u[4]; uu3[1][2] = u[7];
        uu3[2][0] = u[2]; uu3[2][1] = u[5]; uu3[2][2] = u[8];
        
/* u rotate r_1 to r_2 */
    }
/* ccc */
/* ccc Write superposed coordinates in rasmol script */
    if (mout == 1 && ilist == 0) {
	o__1.oerr = 0;
	o__1.ounit = 9;
	o__1.ofnmlen = 100;
	o__1.ofnm = outname;
	o__1.orl = 0;
	o__1.osta = "unknown";
	o__1.oacc = 0;
	o__1.ofm = 0;
	o__1.oblnk = 0;
	f_open(&o__1);
/* *  rasmol   script: */
	s_wsfe(&io___66);
	do_fio(&c__1, "load inline", (ftnlen)11);
	e_wsfe();
	s_wsfe(&io___67);
	do_fio(&c__1, "select atomno<2000", (ftnlen)18);
	e_wsfe();
	s_wsfe(&io___68);
	do_fio(&c__1, "wireframe .45", (ftnlen)13);
	e_wsfe();
	s_wsfe(&io___69);
	do_fio(&c__1, "select none", (ftnlen)11);
	e_wsfe();
	s_wsfe(&io___70);
	do_fio(&c__1, "select atomno>2000", (ftnlen)18);
	e_wsfe();
	s_wsfe(&io___71);
	do_fio(&c__1, "wireframe .20", (ftnlen)13);
	e_wsfe();
	s_wsfe(&io___72);
	do_fio(&c__1, "color white", (ftnlen)11);
	e_wsfe();
	i__1 = n8_al__;
	for (i__ = 1; i__ <= i__1; ++i__) {
/* Computing 2nd power */
	    r__1 = xtm1[i__ - 1] - xtm2[i__ - 1];
/* Computing 2nd power */
	    r__2 = ytm1[i__ - 1] - ytm2[i__ - 1];
/* Computing 2nd power */
	    r__3 = ztm1[i__ - 1] - ztm2[i__ - 1];
	    dis2 = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
	    if (dis2 <= (float)5.) {
		s_wsfe(&io___73);
		do_fio(&c__1, (char *)&m1[i__ - 1], (ftnlen)sizeof(integer));
		e_wsfe();
		s_wsfe(&io___74);
		do_fio(&c__1, "color red", (ftnlen)9);
		e_wsfe();
		s_wsfe(&io___75);
		i__2 = m2[i__ - 1] + 2000;
		do_fio(&c__1, (char *)&i__2, (ftnlen)sizeof(integer));
		e_wsfe();
		s_wsfe(&io___76);
		do_fio(&c__1, "color red", (ftnlen)9);
		e_wsfe();
	    }
	}
	s_wsfe(&io___77);
	do_fio(&c__1, "select all", (ftnlen)10);
	e_wsfe();
	s_wsfe(&io___78);
	do_fio(&c__1, "exit", (ftnlen)4);
	e_wsfe();
	s_wsfe(&io___79);
	do_fio(&c__1, pdb, (ftnlen)100);
	do_fio(&c__1, (char *)&length_1.nseq1, (ftnlen)sizeof(integer));
	e_wsfe();
	s_wsfe(&io___80);
	do_fio(&c__1, pdb + 100, (ftnlen)100);
	do_fio(&c__1, (char *)&length_1.nseq2, (ftnlen)sizeof(integer));
	e_wsfe();
	s_wsfe(&io___81);
	do_fio(&c__1, (char *)&n8_al__, (ftnlen)sizeof(integer));
	do_fio(&c__1, (char *)&rmsd8_al__, (ftnlen)sizeof(real));
	do_fio(&c__1, (char *)&tm8, (ftnlen)sizeof(real));
	e_wsfe();
/* **   chain1: */
	i__1 = n8_al__;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    s_wsfe(&io___82);
	    do_fio(&c__1, (char *)&m1[i__ - 1], (ftnlen)sizeof(integer));
	    do_fio(&c__1, resn + (m1[i__ - 1] - 1) * 3, (ftnlen)3);
	    do_fio(&c__1, (char *)&ires[m1[i__ - 1] - 1], (ftnlen)sizeof(
		    integer));
	    do_fio(&c__1, (char *)&xtm1[i__ - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&ytm1[i__ - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&ztm1[i__ - 1], (ftnlen)sizeof(real));
	    e_wsfe();
	}
	s_wsfe(&io___83);
	e_wsfe();
/* TER */
	i__1 = n8_al__;
	for (i__ = 2; i__ <= i__1; ++i__) {
	    s_wsfe(&io___84);
	    do_fio(&c__1, (char *)&m1[i__ - 2], (ftnlen)sizeof(integer));
	    do_fio(&c__1, (char *)&m1[i__ - 1], (ftnlen)sizeof(integer));
	    e_wsfe();
/* connect atoms */
	}
/* **   chain2: */
	i__1 = n8_al__;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    s_wsfe(&io___85);
	    i__2 = m2[i__ - 1] + 2000;
	    do_fio(&c__1, (char *)&i__2, (ftnlen)sizeof(integer));
	    do_fio(&c__1, resn + (m2[i__ - 1] + 2999) * 3, (ftnlen)3);
	    do_fio(&c__1, (char *)&ires[m2[i__ - 1] + 2999], (ftnlen)sizeof(
		    integer));
	    do_fio(&c__1, (char *)&xtm2[i__ - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&ytm2[i__ - 1], (ftnlen)sizeof(real));
	    do_fio(&c__1, (char *)&ztm2[i__ - 1], (ftnlen)sizeof(real));
	    e_wsfe();
	}
	s_wsfe(&io___86);
	e_wsfe();
	i__1 = n8_al__;
	for (i__ = 2; i__ <= i__1; ++i__) {
	    s_wsfe(&io___87);
	    i__2 = m2[i__ - 2] + 2000;
	    do_fio(&c__1, (char *)&i__2, (ftnlen)sizeof(integer));
	    i__3 = m2[i__ - 1] + 2000;
	    do_fio(&c__1, (char *)&i__3, (ftnlen)sizeof(integer));
	    e_wsfe();
	}
    }
    cl__1.cerr = 0;
    cl__1.cunit = 9;
    cl__1.csta = 0;
    f_clos(&cl__1);
/* ccc */
/* ccc Write the structure based sequence alignment */
    
    *aln3_length   = n8_al__;
    *aln3_rmsd     = rmsd8_al__;
    *aln3_tmscore  = tm8;
    *aln3_identity = seq_id__;
    
    i__1 = n8_al__;
    for (i__ = 1; i__ <= i__1; ++i__) {
     align3[i__ - 1][0] = m1[i__ - 1] - 1;
     align3[i__ - 1][1] = m2[i__ - 1] - 1;
    }
	    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    if (ilist == 0) {
/* ccc        call header */
/* ccc        write(6,105)pdb(1),nseq1 */
/* ccc        write(6,106)pdb(2),nseq2,int(anseq) */
/* ccc        write(6,*) */
/* ccc        write(6,107)n8_al,rmsd8_al,TM8,seq_id */
/* ccc 105  format('Chain 1:',A10,'  Size=',I4) */
/* ccc 106  format('Chain 2:',A10,'  Size=',I4, */
/* ccc     &' (TM-score is normalized by ',I4,')') */
/* ccc 107  format('Aligned length=',I4,', RMSD=',f6.2, */
/* ccc     &     ', TM-score=',f7.5,', ID=',f5.3) */
/* ccc      write(6,*) */
	ii = 0;
	i1_old__ = 1;
	i2_old__ = 1;
	i__1 = n8_al__;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    i__2 = m1[i__ - 1] - 1;
	    for (j = i1_old__; j <= i__2; ++j) {
		++ii;
		*(unsigned char *)&aseq1[ii - 1] = *(unsigned char *)&seqn[j 
			- 1];
		*(unsigned char *)&aseq2[ii - 1] = '-';
		*(unsigned char *)&aseq3[ii - 1] = ' ';
	    }
	    i__2 = m2[i__ - 1] - 1;
	    for (j = i2_old__; j <= i__2; ++j) {
		++ii;
		*(unsigned char *)&aseq1[ii - 1] = '-';
		*(unsigned char *)&aseq2[ii - 1] = *(unsigned char *)&seqn[j 
			+ 2999];
		*(unsigned char *)&aseq3[ii - 1] = ' ';
	    }
	    ++ii;
	    *(unsigned char *)&aseq1[ii - 1] = *(unsigned char *)&seqn[m1[i__ 
		    - 1] - 1];
	    *(unsigned char *)&aseq2[ii - 1] = *(unsigned char *)&seqn[m2[i__ 
		    - 1] + 2999];
/* Computing 2nd power */
	    r__1 = xtm1[i__ - 1] - xtm2[i__ - 1];
/* Computing 2nd power */
	    r__2 = ytm1[i__ - 1] - ytm2[i__ - 1];
/* Computing 2nd power */
	    r__3 = ztm1[i__ - 1] - ztm2[i__ - 1];
	    dis2 = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
	    if (dis2 <= (float)5.) {
		*(unsigned char *)&aseq3[ii - 1] = ':';
	    } else {
		*(unsigned char *)&aseq3[ii - 1] = '.';
	    }
	    i1_old__ = m1[i__ - 1] + 1;
	    i2_old__ = m2[i__ - 1] + 1;
	}
	i__1 = length_1.nseq1;
	for (i__ = i1_old__; i__ <= i__1; ++i__) {
	    ++ii;
	    *(unsigned char *)&aseq1[ii - 1] = *(unsigned char *)&seqn[i__ - 
		    1];
	    *(unsigned char *)&aseq2[ii - 1] = '-';
	    *(unsigned char *)&aseq3[ii - 1] = ' ';
	}
	i__1 = length_1.nseq2;
	for (i__ = i2_old__; i__ <= i__1; ++i__) {
	    ++ii;
	    *(unsigned char *)&aseq1[ii - 1] = '-';
	    *(unsigned char *)&aseq2[ii - 1] = *(unsigned char *)&seqn[i__ + 
		    2999];
	    *(unsigned char *)&aseq3[ii - 1] = ' ';
	}
/* ccc      write(6,50) */
/* ccc 50   format('(":" denotes the residue pairs of distance < 5.0 ', */
/* ccc     &     'Angstrom)') */
/* ccc      write(6,10)(aseq1(i),i=1,ii) */
/* ccc      write(6,10)(aseq3(i),i=1,ii) */
/* ccc      write(6,10)(aseq2(i),i=1,ii) */
/* ccc 10   format(10000A1) */
/* ccc      write(6,*) */
    }
    
    return 0;
} /* MAIN_FR__ */

/* ***************************************************************** */
/* ***            Subroutines */
/* ***************************************************************** */
/* ccc making initial superposition */
/* Subroutine */ int super_align__(real *dx, real *dxs, integer *invmap0, 
	integer *ir_type__)
{
    extern /* Subroutine */ int fragscan_(real *, real *, integer *, integer *
	    , real *), assignssp_();
    static real atm;

/* secondary structure */
    /* Parameter adjustments */
    --invmap0;

    /* Function Body */
    assignssp_();
/* secondary structure assignment */
    fragscan_(dx, dxs, &invmap0[1], ir_type__, &atm);
    return 0;
} /* super_align__ */

/* ccc for getting the best alignment */
/* Subroutine */ int getbest_(real *atm, integer *invmapi, real *atmmax, 
	integer *invmapr)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer j;

    /* Parameter adjustments */
    --invmapr;
    --invmapi;

    /* Function Body */
    if (*atm > *atmmax) {
	*atmmax = *atm;
	i__1 = length_1.nseq2;
	for (j = 1; j <= i__1; ++j) {
	    invmapr[j] = invmapi[j];
	}
    }
    return 0;
} /* getbest_ */

/* ccc making secondary structure assignment */
/* Subroutine */ int assignssp_()
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    extern integer make_sec__(real *, real *, real *, real *, real *, real *);
    static integer i__, j1, j2, j3, j4, j5;
    static real dis13, dis14, dis15, dis24, dis25, dis35;
    extern doublereal diszy_(integer *, integer *, integer *);
    extern /* Subroutine */ int smooth_();

/* secondary structure */
    i__1 = length_1.nseq1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	secstr_1.isec[i__ - 1] = 1;
	j1 = i__ - 2;
	j2 = i__ - 1;
	j3 = i__;
	j4 = i__ + 1;
	j5 = i__ + 2;
	if (j1 >= 1 && j5 <= length_1.nseq1) {
	    dis13 = diszy_(&c__0, &j1, &j3);
	    dis14 = diszy_(&c__0, &j1, &j4);
	    dis15 = diszy_(&c__0, &j1, &j5);
	    dis24 = diszy_(&c__0, &j2, &j4);
	    dis25 = diszy_(&c__0, &j2, &j5);
	    dis35 = diszy_(&c__0, &j3, &j5);
	    secstr_1.isec[i__ - 1] = make_sec__(&dis13, &dis14, &dis15, &
		    dis24, &dis25, &dis35);
	}
    }
    i__1 = length_1.nseq2;
    for (i__ = 1; i__ <= i__1; ++i__) {
	secstr_1.jsec[i__ - 1] = 1;
	j1 = i__ - 2;
	j2 = i__ - 1;
	j3 = i__;
	j4 = i__ + 1;
	j5 = i__ + 2;
	if (j1 >= 1 && j5 <= length_1.nseq2) {
	    dis13 = diszy_(&c__1, &j1, &j3);
	    dis14 = diszy_(&c__1, &j1, &j4);
	    dis15 = diszy_(&c__1, &j1, &j5);
	    dis24 = diszy_(&c__1, &j2, &j4);
	    dis25 = diszy_(&c__1, &j2, &j5);
	    dis35 = diszy_(&c__1, &j3, &j5);
	    secstr_1.jsec[i__ - 1] = make_sec__(&dis13, &dis14, &dis15, &
		    dis24, &dis25, &dis35);
	}
    }
    smooth_();
/* smooth the assignment */
    return 0;
} /* assignssp_ */

/* ccc make secondary str */
integer make_sec__(real *dis13, real *dis14, real *dis15, real *dis24, real *
	dis25, real *dis35)
{
    /* System generated locals */
    integer ret_val;
    real r__1;

    /* Local variables */
    static real delta;

    ret_val = 1;
    delta = (float)2.1;
    if ((r__1 = *dis15 - (float)6.37, dabs(r__1)) < delta) {
	if ((r__1 = *dis14 - (float)5.18, dabs(r__1)) < delta) {
	    if ((r__1 = *dis25 - (float)5.18, dabs(r__1)) < delta) {
		if ((r__1 = *dis13 - (float)5.45, dabs(r__1)) < delta) {
		    if ((r__1 = *dis24 - (float)5.45, dabs(r__1)) < delta) {
			if ((r__1 = *dis35 - (float)5.45, dabs(r__1)) < delta)
				 {
			    ret_val = 2;
/* helix */
			    return ret_val;
			}
		    }
		}
	    }
	}
    }
    delta = (float)1.42;
    if ((r__1 = *dis15 - 13, dabs(r__1)) < delta) {
	if ((r__1 = *dis14 - (float)10.4, dabs(r__1)) < delta) {
	    if ((r__1 = *dis25 - (float)10.4, dabs(r__1)) < delta) {
		if ((r__1 = *dis13 - (float)6.1, dabs(r__1)) < delta) {
		    if ((r__1 = *dis24 - (float)6.1, dabs(r__1)) < delta) {
			if ((r__1 = *dis35 - (float)6.1, dabs(r__1)) < delta) 
				{
			    ret_val = 4;
/* strand */
			    return ret_val;
			}
		    }
		}
	    }
	}
    }
    if (*dis15 < (float)8.) {
	ret_val = 3;
    }
    return ret_val;
} /* make_sec__ */

/* ccc smooth the secondary structure assignment */
/* Subroutine */ int smooth_()
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__, j;

/* **   smooth single --------------> */
/* **   --x-- => ----- */
/* secondary structure */
    i__1 = length_1.nseq1;
    for (i__ = 3; i__ <= i__1; ++i__) {
	if (secstr_1.isec[i__ - 1] == 2 || secstr_1.isec[i__ - 1] == 4) {
	    j = secstr_1.isec[i__ - 1];
	    if (secstr_1.isec[i__ - 3] != j) {
		if (secstr_1.isec[i__ - 2] != j) {
		    if (secstr_1.isec[i__] != j) {
			if (secstr_1.isec[i__] != j) {
			    secstr_1.isec[i__ - 1] = 1;
			}
		    }
		}
	    }
	}
    }
    i__1 = length_1.nseq2;
    for (i__ = 3; i__ <= i__1; ++i__) {
	if (secstr_1.jsec[i__ - 1] == 2 || secstr_1.jsec[i__ - 1] == 4) {
	    j = secstr_1.jsec[i__ - 1];
	    if (secstr_1.jsec[i__ - 3] != j) {
		if (secstr_1.jsec[i__ - 2] != j) {
		    if (secstr_1.jsec[i__] != j) {
			if (secstr_1.jsec[i__] != j) {
			    secstr_1.jsec[i__ - 1] = 1;
			}
		    }
		}
	    }
	}
    }
/* **   smooth double --------------> */
/* **   --xx-- => ------ */
    i__1 = length_1.nseq1 - 5;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (secstr_1.isec[i__ - 1] != 2) {
	    if (secstr_1.isec[i__] != 2) {
		if (secstr_1.isec[i__ + 1] == 2) {
		    if (secstr_1.isec[i__ + 2] == 2) {
			if (secstr_1.isec[i__ + 3] != 2) {
			    if (secstr_1.isec[i__ + 4] != 2) {
				secstr_1.isec[i__ + 1] = 1;
				secstr_1.isec[i__ + 2] = 1;
			    }
			}
		    }
		}
	    }
	}
	if (secstr_1.isec[i__ - 1] != 4) {
	    if (secstr_1.isec[i__] != 4) {
		if (secstr_1.isec[i__ + 1] == 4) {
		    if (secstr_1.isec[i__ + 2] == 4) {
			if (secstr_1.isec[i__ + 3] != 4) {
			    if (secstr_1.isec[i__ + 4] != 4) {
				secstr_1.isec[i__ + 1] = 1;
				secstr_1.isec[i__ + 2] = 1;
			    }
			}
		    }
		}
	    }
	}
    }
    i__1 = length_1.nseq2 - 5;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (secstr_1.jsec[i__ - 1] != 2) {
	    if (secstr_1.jsec[i__] != 2) {
		if (secstr_1.jsec[i__ + 1] == 2) {
		    if (secstr_1.jsec[i__ + 2] == 2) {
			if (secstr_1.jsec[i__ + 3] != 2) {
			    if (secstr_1.jsec[i__ + 4] != 2) {
				secstr_1.jsec[i__ + 1] = 1;
				secstr_1.jsec[i__ + 2] = 1;
			    }
			}
		    }
		}
	    }
	}
	if (secstr_1.jsec[i__ - 1] != 4) {
	    if (secstr_1.jsec[i__] != 4) {
		if (secstr_1.jsec[i__ + 1] == 4) {
		    if (secstr_1.jsec[i__ + 2] == 4) {
			if (secstr_1.jsec[i__ + 3] != 4) {
			    if (secstr_1.jsec[i__ + 4] != 4) {
				secstr_1.jsec[i__ + 1] = 1;
				secstr_1.jsec[i__ + 2] = 1;
			    }
			}
		    }
		}
	    }
	}
    }
/* **   connect --------------> */
/* **   x-x => xxx */
    i__1 = length_1.nseq1 - 2;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (secstr_1.isec[i__ - 1] == 2) {
	    if (secstr_1.isec[i__] != 2) {
		if (secstr_1.isec[i__ + 1] == 2) {
		    secstr_1.isec[i__] = 2;
		}
	    }
	}
	if (secstr_1.isec[i__ - 1] == 4) {
	    if (secstr_1.isec[i__] != 4) {
		if (secstr_1.isec[i__ + 1] == 4) {
		    secstr_1.isec[i__] = 4;
		}
	    }
	}
    }
    i__1 = length_1.nseq2 - 2;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (secstr_1.jsec[i__ - 1] == 2) {
	    if (secstr_1.jsec[i__] != 2) {
		if (secstr_1.jsec[i__ + 1] == 2) {
		    secstr_1.jsec[i__] = 2;
		}
	    }
	}
	if (secstr_1.jsec[i__ - 1] == 4) {
	    if (secstr_1.jsec[i__] != 4) {
		if (secstr_1.jsec[i__ + 1] == 4) {
		    secstr_1.jsec[i__] = 4;
		}
	    }
	}
    }
    return 0;
} /* smooth_ */

/* ccc distance calculation */
doublereal diszy_(integer *i__, integer *i1, integer *i2)
{
    /* System generated locals */
    real ret_val, r__1, r__2, r__3;

    /* Builtin functions */
    double sqrt(doublereal);

/* Computing 2nd power */
    r__1 = coord_1.xa[(*i1 + *i__ * 3000) * 3 - 3] - coord_1.xa[(*i2 + *i__ * 
	    3000) * 3 - 3];
/* Computing 2nd power */
    r__2 = coord_1.xa[(*i1 + *i__ * 3000) * 3 - 2] - coord_1.xa[(*i2 + *i__ * 
	    3000) * 3 - 2];
/* Computing 2nd power */
    r__3 = coord_1.xa[(*i1 + *i__ * 3000) * 3 - 1] - coord_1.xa[(*i2 + *i__ * 
	    3000) * 3 - 1];
    ret_val = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
    return ret_val;
} /* diszy_ */

/* ccc reading pdb file */
/* Subroutine */ int readpdb_(char *filen, integer *np, integer *nlen, char *
	aanam1, char *aanam2, real *xyz, ftnlen filen_len, ftnlen aanam1_len, 
	ftnlen aanam2_len)
{
    /* Format strings */
    static char fmt_91[] = "(a100)";
    static char fmt_90[] = "(a17,a3,a2,i4,a4,3f8.3)";

    /* System generated locals */
    integer i__1;
    olist o__1;
    cllist cl__1;

    /* Builtin functions */
    integer f_open(olist *), s_wsle(cilist *), do_lio(integer *, integer *, 
	    char *, ftnlen), e_wsle();
    /* Subroutine */ int s_stop(char *, ftnlen);
    integer s_rsfe(cilist *), do_fio(integer *, char *, ftnlen), e_rsfe(), 
	    s_cmp(char *, char *, ftnlen, ftnlen), s_rsfi(icilist *), e_rsfi()
	    , f_clos(cllist *), i_indx(char *, char *, ftnlen, ftnlen);
    /* Subroutine */ int s_copy(char *, char *, ftnlen, ftnlen);

    /* Local variables */
    static integer i__, j, kk, io, nii, ios;
    static char fnam[100], buffer[100];

    /* Fortran I/O blocks */
    static cilist io___115 = { 0, 6, 0, 0, 0 };
    static cilist io___117 = { 0, 10, 1, fmt_91, 0 };
    static cilist io___119 = { 0, 6, 0, 0, 0 };
    static icilist io___120 = { 0, buffer, 0, fmt_90, 100, 1 };
    static cilist io___123 = { 0, 6, 0, 0, 0 };


/* filen: file name, np: 0 or 1 */
/* no. of residues */
    /* Parameter adjustments */
    xyz -= 9004;
    aanam2 -= -2;
    aanam1 -= -6;

    /* Function Body */
    nii = 60;
    while(*(unsigned char *)&filen[nii - 1] == ' ') {
	--nii;
    }
    o__1.oerr = 1;
    o__1.ounit = 10;
    o__1.ofnmlen = nii;
    o__1.ofnm = filen;
    o__1.orl = 0;
    o__1.osta = "old";
    o__1.oacc = 0;
    o__1.ofm = 0;
    o__1.oblnk = 0;
    ios = f_open(&o__1);
    if (ios != 0) {
	s_wsle(&io___115);
	do_lio(&c__9, &c__1, "Error in opening PDB file ", (ftnlen)26);
	do_lio(&c__9, &c__1, filen, nii);
	do_lio(&c__9, &c__1, ". Exiting now", (ftnlen)13);
	e_wsle();
	s_stop("", (ftnlen)0);
    }
    i__ = 0;
    while(TRUE_) {
	i__1 = s_rsfe(&io___117);
	if (i__1 != 0) {
	    goto L101;
	}
	i__1 = do_fio(&c__1, buffer, (ftnlen)100);
	if (i__1 != 0) {
	    goto L101;
	}
	i__1 = e_rsfe();
	if (i__1 != 0) {
	    goto L101;
	}
	if (i__ > 0) {
	    if (s_cmp(buffer, "ENDMDL", (ftnlen)6, (ftnlen)6) == 0) {
		s_wsle(&io___119);
		do_lio(&c__9, &c__1, "Warning: PDB contains multiple models,\
                only first model will be used", (ftnlen)83);
		e_wsle();
	    }
	    if (s_cmp(buffer, "TER", (ftnlen)3, (ftnlen)3) == 0 || s_cmp(
		    buffer, "END", (ftnlen)3, (ftnlen)3) == 0) {
		goto L101;
	    }
	}
	if ((s_cmp(buffer, "ATOM", (ftnlen)4, (ftnlen)4) == 0) || (s_cmp(buffer, 
		"HETATM", (ftnlen)6, (ftnlen)6) == 0 && s_cmp(buffer + 16, 
		"MSE", (ftnlen)4, (ftnlen)3) == 0)) {
	    if (s_cmp(buffer + 12, " CA ", (ftnlen)4, (ftnlen)4) == 0 || 
		    s_cmp(buffer + 12, "  CA", (ftnlen)4, (ftnlen)4) == 0 || 
		    s_cmp(buffer + 12, "CA  ", (ftnlen)4, (ftnlen)4) == 0) {
		if (*(unsigned char *)&buffer[16] == ' ' || *(unsigned char *)
			&buffer[16] == 'A') {
		    ++i__;
		    s_rsfi(&io___120);
		    do_fio(&c__1, fnam, (ftnlen)100);
		    do_fio(&c__1, pdbinfo_1.resa + (i__ + *np * 3000 - 3001) *
			     3, (ftnlen)3);
		    do_fio(&c__1, fnam, (ftnlen)100);
		    do_fio(&c__1, (char *)&pdbinfo_1.ires1[i__ + *np * 3000 - 
			    3001], (ftnlen)sizeof(integer));
		    do_fio(&c__1, fnam, (ftnlen)100);
		    do_fio(&c__1, (char *)&xyz[(i__ + *np * 3000) * 3 + 1], (
			    ftnlen)sizeof(real));
		    do_fio(&c__1, (char *)&xyz[(i__ + *np * 3000) * 3 + 2], (
			    ftnlen)sizeof(real));
		    do_fio(&c__1, (char *)&xyz[(i__ + *np * 3000) * 3 + 3], (
			    ftnlen)sizeof(real));
		    e_rsfi();
		    for (j = -2; j <= 20; ++j) {
			if (s_cmp(pdbinfo_1.resa + (i__ + *np * 3000 - 3001) *
				 3, aanam1 + j * 3, (ftnlen)3, (ftnlen)3) == 
				0) {
			    *(unsigned char *)&pdbinfo_1.seqa[i__ + *np * 
				    3000 - 3001] = *(unsigned char *)&aanam2[
				    j];
			}
		    }
		}
	    }
	}
    }
L101:
    cl__1.cerr = 0;
    cl__1.cunit = 10;
    cl__1.csta = 0;
    f_clos(&cl__1);
    if (i__ == 0) {
	s_wsle(&io___123);
	do_lio(&c__9, &c__1, "Error in reading PDB file ", (ftnlen)26);
	do_lio(&c__9, &c__1, filen, nii);
	do_lio(&c__9, &c__1, ". Exiting now", (ftnlen)13);
	e_wsle();
	s_stop("", (ftnlen)0);
    }
    *nlen = i__;
/* ! If PDB is not in the present dir. then rename pdb file name!! */
    if (i_indx(filen, "/", nii, (ftnlen)1) != 0) {
	io = 0;
	kk = 1;
	while(kk != 0) {
	    i__1 = io;
	    kk = i_indx(filen + i__1, "/", 100 - i__1, (ftnlen)1);
	    io += kk;
	}
	i__1 = io;
	s_copy(fnam, filen + i__1, (ftnlen)100, nii - i__1);
	s_copy(filen, fnam, (ftnlen)100, (ftnlen)100);
    }
    return 0;
} /* readpdb_ */

/* ccc Instruction for running of the program */
/* Subroutine */ int instru_()
{
    /* Builtin functions */
    integer s_wsle(cilist *), do_lio(integer *, integer *, char *, ftnlen), 
	    e_wsle();
    /* Subroutine */ int s_stop(char *, ftnlen);

    /* Local variables */
    extern /* Subroutine */ int header_();

    /* Fortran I/O blocks */
    static cilist io___126 = { 0, 6, 0, 0, 0 };
    static cilist io___127 = { 0, 6, 0, 0, 0 };
    static cilist io___128 = { 0, 6, 0, 0, 0 };
    static cilist io___129 = { 0, 6, 0, 0, 0 };
    static cilist io___130 = { 0, 6, 0, 0, 0 };
    static cilist io___131 = { 0, 6, 0, 0, 0 };
    static cilist io___132 = { 0, 6, 0, 0, 0 };
    static cilist io___133 = { 0, 6, 0, 0, 0 };
    static cilist io___134 = { 0, 6, 0, 0, 0 };
    static cilist io___135 = { 0, 6, 0, 0, 0 };
    static cilist io___136 = { 0, 6, 0, 0, 0 };
    static cilist io___137 = { 0, 6, 0, 0, 0 };
    static cilist io___138 = { 0, 6, 0, 0, 0 };
    static cilist io___139 = { 0, 6, 0, 0, 0 };
    static cilist io___140 = { 0, 6, 0, 0, 0 };
    static cilist io___141 = { 0, 6, 0, 0, 0 };
    static cilist io___142 = { 0, 6, 0, 0, 0 };
    static cilist io___143 = { 0, 6, 0, 0, 0 };
    static cilist io___144 = { 0, 6, 0, 0, 0 };
    static cilist io___145 = { 0, 6, 0, 0, 0 };
    static cilist io___146 = { 0, 6, 0, 0, 0 };
    static cilist io___147 = { 0, 6, 0, 0, 0 };
    static cilist io___148 = { 0, 6, 0, 0, 0 };
    static cilist io___149 = { 0, 6, 0, 0, 0 };
    static cilist io___150 = { 0, 6, 0, 0, 0 };
    static cilist io___151 = { 0, 6, 0, 0, 0 };
    static cilist io___152 = { 0, 6, 0, 0, 0 };
    static cilist io___153 = { 0, 6, 0, 0, 0 };
    static cilist io___154 = { 0, 6, 0, 0, 0 };
    static cilist io___155 = { 0, 6, 0, 0, 0 };
    static cilist io___156 = { 0, 6, 0, 0, 0 };


    header_();
    s_wsle(&io___126);
    do_lio(&c__9, &c__1, "Instructions for running Fr-TM-align program:", (
	    ftnlen)45);
    e_wsle();
    s_wsle(&io___127);
    e_wsle();
    s_wsle(&io___128);
    do_lio(&c__9, &c__1, "Required arguments:", (ftnlen)19);
    e_wsle();
    s_wsle(&io___129);
    e_wsle();
    s_wsle(&io___130);
    do_lio(&c__9, &c__1, "Two structures. Aligns structure.pdb to target.pdb",
	     (ftnlen)50);
    e_wsle();
    s_wsle(&io___131);
    do_lio(&c__9, &c__1, "(By default, TM-score is normalized by the length", 
	    (ftnlen)49);
    do_lio(&c__9, &c__1, "of the target.pdb)", (ftnlen)18);
    e_wsle();
    s_wsle(&io___132);
    do_lio(&c__9, &c__1, "./TMalign structure.pdb target.pdb", (ftnlen)34);
    e_wsle();
    s_wsle(&io___133);
    e_wsle();
    s_wsle(&io___134);
    do_lio(&c__9, &c__1, "Optional arguments:", (ftnlen)19);
    e_wsle();
    s_wsle(&io___135);
    e_wsle();
    s_wsle(&io___136);
    do_lio(&c__9, &c__1, "-f : <0 or 1 > Default is 0. This option is to cho\
ose", (ftnlen)53);
    e_wsle();
    s_wsle(&io___137);
    do_lio(&c__9, &c__1, "     slow or fast algorithm for structural alignme\
nt", (ftnlen)52);
    e_wsle();
    s_wsle(&io___138);
    do_lio(&c__9, &c__1, "     0 - is slow algorithm is used and ", (ftnlen)
	    39);
    e_wsle();
    s_wsle(&io___139);
    do_lio(&c__9, &c__1, "     1 - fast algorithm is used for alignment", (
	    ftnlen)45);
    e_wsle();
    s_wsle(&io___140);
    do_lio(&c__9, &c__1, "", (ftnlen)0);
    e_wsle();
    s_wsle(&io___141);
    do_lio(&c__9, &c__1, "-o : Output the superposed coordinates in a file", (
	    ftnlen)48);
    e_wsle();
    s_wsle(&io___142);
    do_lio(&c__9, &c__1, "    ./TMalign structure.pdb target.pdb -o TM.sup", (
	    ftnlen)48);
    e_wsle();
    s_wsle(&io___143);
    do_lio(&c__9, &c__1, "    (To view the superimposed structures by rasmol:"
	    , (ftnlen)51);
    do_lio(&c__9, &c__1, "./rasmol -script TM.sup)", (ftnlen)24);
    e_wsle();
    s_wsle(&io___144);
    e_wsle();
    s_wsle(&io___145);
    do_lio(&c__9, &c__1, "-l : TM-score to be normalized by the given length",
	     (ftnlen)50);
    e_wsle();
    s_wsle(&io___146);
    do_lio(&c__9, &c__1, "    ./TMalign structure.pdb target.pdb -L 100", (
	    ftnlen)45);
    e_wsle();
    s_wsle(&io___147);
    e_wsle();
    s_wsle(&io___148);
    do_lio(&c__9, &c__1, "-m : <0 or 1 > If -m = 1, stores the rotation", (
	    ftnlen)45);
    e_wsle();
    s_wsle(&io___149);
    do_lio(&c__9, &c__1, "     matrix in trf.mat file. Default value is 0.", (
	    ftnlen)48);
    e_wsle();
    s_wsle(&io___150);
    do_lio(&c__9, &c__1, "    ./TMalign structure.pdb target.pdb -m 1", (
	    ftnlen)43);
    e_wsle();
    s_wsle(&io___151);
    e_wsle();
    s_wsle(&io___152);
    do_lio(&c__9, &c__1, "-a : <0 or 1 > If -a = 0, aligns only two structur\
es, pdbid read from", (ftnlen)69);
    e_wsle();
    s_wsle(&io___153);
    do_lio(&c__9, &c__1, "     standard input. If -a = 1, program compares a\
 list of proteins", (ftnlen)67);
    e_wsle();
    s_wsle(&io___154);
    do_lio(&c__9, &c__1, "     against one target PDB", (ftnlen)27);
    e_wsle();
    s_wsle(&io___155);
    do_lio(&c__9, &c__1, "    ./TMalign -a 1 list target.pdb ", (ftnlen)35);
    e_wsle();
    s_wsle(&io___156);
    do_lio(&c__9, &c__1, " ", (ftnlen)1);
    e_wsle();
    s_stop("", (ftnlen)0);
    return 0;
} /* instru_ */

/* Subroutine */ int header_()
{
    /* Builtin functions */
    integer s_wsle(cilist *), e_wsle(), do_lio(integer *, integer *, char *, 
	    ftnlen);

    /* Fortran I/O blocks */
    static cilist io___157 = { 0, 6, 0, 0, 0 };
    static cilist io___158 = { 0, 6, 0, 0, 0 };
    static cilist io___159 = { 0, 6, 0, 0, 0 };
    static cilist io___160 = { 0, 6, 0, 0, 0 };
    static cilist io___161 = { 0, 6, 0, 0, 0 };
    static cilist io___162 = { 0, 6, 0, 0, 0 };
    static cilist io___163 = { 0, 6, 0, 0, 0 };
    static cilist io___164 = { 0, 6, 0, 0, 0 };
    static cilist io___165 = { 0, 6, 0, 0, 0 };
    static cilist io___166 = { 0, 6, 0, 0, 0 };


    s_wsle(&io___157);
    e_wsle();
    s_wsle(&io___158);
    do_lio(&c__9, &c__1, "**************************************************\
**", (ftnlen)52);
    do_lio(&c__9, &c__1, "***********", (ftnlen)11);
    e_wsle();
    s_wsle(&io___159);
    do_lio(&c__9, &c__1, "**                         Fr-TM-TMalign          \
  ", (ftnlen)52);
    do_lio(&c__9, &c__1, "         **", (ftnlen)11);
    e_wsle();
    s_wsle(&io___160);
    do_lio(&c__9, &c__1, "** A protein structutal alignment program based on\
 f", (ftnlen)52);
    do_lio(&c__9, &c__1, "ragment  **", (ftnlen)11);
    e_wsle();
    s_wsle(&io___161);
    do_lio(&c__9, &c__1, "** assembly and TM-score                          \
  ", (ftnlen)52);
    do_lio(&c__9, &c__1, "         **", (ftnlen)11);
    e_wsle();
    s_wsle(&io___162);
    do_lio(&c__9, &c__1, "**                                                \
  ", (ftnlen)52);
    do_lio(&c__9, &c__1, "         **", (ftnlen)11);
    e_wsle();
    s_wsle(&io___163);
    do_lio(&c__9, &c__1, "** Comments and bugs email to :                   \
  ", (ftnlen)52);
    do_lio(&c__9, &c__1, "         **", (ftnlen)11);
    e_wsle();
    s_wsle(&io___164);
    do_lio(&c__9, &c__1, "** spandit3@mail.gatech.edu                       \
  ", (ftnlen)52);
    do_lio(&c__9, &c__1, "         **", (ftnlen)11);
    e_wsle();
    s_wsle(&io___165);
    do_lio(&c__9, &c__1, "**************************************************\
**", (ftnlen)52);
    do_lio(&c__9, &c__1, "***********", (ftnlen)11);
    e_wsle();
    s_wsle(&io___166);
    e_wsle();
    return 0;
} /* header_ */

/* Subroutine */ int fortfunc_(real *ii, real *ff)
{
    /* Format strings */
    static char fmt_176[] = "(\002ii=\002,f6.3,\002 ff=\002,f6.3)";

    /* Builtin functions */
    integer s_wsfe(cilist *), do_fio(integer *, char *, ftnlen), e_wsfe();

    /* Fortran I/O blocks */
    static cilist io___167 = { 0, 6, 0, fmt_176, 0 };


    s_wsfe(&io___167);
    do_fio(&c__1, (char *)&(*ii), (ftnlen)sizeof(real));
    do_fio(&c__1, (char *)&(*ff), (ftnlen)sizeof(real));
    e_wsfe();
    return 0;
} /* fortfunc_ */

/* ccc */
/* cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* ccc  Subroutine to calculate GL-score and secondary structure identity */
/* ccc  for a given fragment length */
/* ccc */
/* cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* Subroutine */ int get_ngl__(integer *ist1, integer *istp1, integer *ist2, 
	integer *istp2, integer *nlen, real *gl, real *ssa, real *ssan)
{
    /* Initialized data */

    static doublereal w[3000] = { 1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1. };

    /* System generated locals */
    integer i__1;
    real r__1, r__2, r__3;

    /* Local variables */
    static integer i__, j, l, istp2_mod__;
    static doublereal t[3], u[9]	/* was [3][3] */;
    static real da, d02, xx, yy, zz, d002;
    static doublereal r_1__[9000]	/* was [3][3000] */, r_2__[9000]	
	    /* was [3][3000] */;
    static real gl1, gl2, gl3;
    extern /* Subroutine */ int u3b_(doublereal *, doublereal *, doublereal *,
	     integer *, integer *, doublereal *, doublereal *, doublereal *, 
	    integer *);
    static real xo1[3000], yo1[3000], zo1[3000], xo2[3000], yo2[3000], zo2[
	    3000];
    static integer ier, iss;
    static real dxs;
    static doublereal rms;
    static real dis2[3000];
    static integer n_al__, issn, idiff1, idiff2;

/* no. of residues */
/* ccc  RMSD: */
/* armsd is real */
    da = (float).5;
/* Computing 2nd power */
    r__1 = da;
    d02 = r__1 * r__1;
    *gl = (float)0.;
    *ssa = (float)0.;
    idiff1 = *istp1 - *ist1 + 1;
    idiff2 = *istp2 - *ist2 + 1;
    istp2_mod__ = *istp2;
    if (idiff1 < idiff2) {
/* second one make second one equal to first fragment */
/* if first fragment is less than */
	istp2_mod__ = *ist2 + idiff1 - 1;
    }
    i__ = *ist1;
    n_al__ = 0;
    iss = 0;
    issn = 0;
    i__1 = istp2_mod__;
    for (j = *ist2; j <= i__1; ++j) {
	++n_al__;
	r_1__[n_al__ * 3 - 3] = coord_1.xa[i__ * 3 - 3];
	r_1__[n_al__ * 3 - 2] = coord_1.xa[i__ * 3 - 2];
	r_1__[n_al__ * 3 - 1] = coord_1.xa[i__ * 3 - 1];
	r_2__[n_al__ * 3 - 3] = coord_1.xa[(j + 3000) * 3 - 3];
	r_2__[n_al__ * 3 - 2] = coord_1.xa[(j + 3000) * 3 - 2];
	r_2__[n_al__ * 3 - 1] = coord_1.xa[(j + 3000) * 3 - 1];
	xo1[n_al__ - 1] = coord_1.xa[i__ * 3 - 3];
	yo1[n_al__ - 1] = coord_1.xa[i__ * 3 - 2];
	zo1[n_al__ - 1] = coord_1.xa[i__ * 3 - 1];
	xo2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 3];
	yo2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 2];
	zo2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 1];
	if (secstr_1.isec[i__ - 1] == secstr_1.jsec[j - 1] && secstr_1.isec[
		i__ - 1] > 1) {
	    ++iss;
	}
	if (secstr_1.isec[i__ - 1] == secstr_1.jsec[j - 1]) {
	    ++issn;
	}
	++i__;
    }
    *ssa = (real) iss / (real) n_al__;
    *ssan = (real) issn / (real) n_al__;
    u3b_(w, r_1__, r_2__, &n_al__, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
    gl1 = (float)0.;
    i__1 = n_al__;
    for (i__ = 1; i__ <= i__1; ++i__) {
	dis2[i__ - 1] = (float)0.;
	xx = t[0] + u[0] * xo1[i__ - 1] + u[3] * yo1[i__ - 1] + u[6] * zo1[
		i__ - 1];
	yy = t[1] + u[1] * xo1[i__ - 1] + u[4] * yo1[i__ - 1] + u[7] * zo1[
		i__ - 1];
	zz = t[2] + u[2] * xo1[i__ - 1] + u[5] * yo1[i__ - 1] + u[8] * zo1[
		i__ - 1];
/* Computing 2nd power */
	r__1 = xx - xo2[i__ - 1];
/* Computing 2nd power */
	r__2 = yy - yo2[i__ - 1];
/* Computing 2nd power */
	r__3 = zz - zo2[i__ - 1];
	dis2[i__ - 1] = r__1 * r__1 + r__2 * r__2 + r__3 * r__3;
	gl1 += 1 / (dis2[i__ - 1] / d02 + 1);
    }
    gl1 /= (real) n_al__;
    dxs = (float)4.5;
/* Computing 2nd power */
    r__1 = dxs;
    d002 = r__1 * r__1;
L20:
    j = 0;
    i__1 = n_al__;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (dis2[i__ - 1] <= d002) {
	    ++j;
	    r_1__[j * 3 - 3] = xo1[i__ - 1];
	    r_1__[j * 3 - 2] = yo1[i__ - 1];
	    r_1__[j * 3 - 1] = zo1[i__ - 1];
	    r_2__[j * 3 - 3] = xo2[i__ - 1];
	    r_2__[j * 3 - 2] = yo2[i__ - 1];
	    r_2__[j * 3 - 1] = zo2[i__ - 1];
	}
    }
    if (j <= 3) {
	d002 += (float).5;
	goto L20;
    }
    l = j;
    u3b_(w, r_1__, r_2__, &l, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
    gl2 = (float)0.;
    i__1 = n_al__;
    for (i__ = 1; i__ <= i__1; ++i__) {
	dis2[i__ - 1] = (float)0.;
	xx = t[0] + u[0] * xo1[i__ - 1] + u[3] * yo1[i__ - 1] + u[6] * zo1[
		i__ - 1];
	yy = t[1] + u[1] * xo1[i__ - 1] + u[4] * yo1[i__ - 1] + u[7] * zo1[
		i__ - 1];
	zz = t[2] + u[2] * xo1[i__ - 1] + u[5] * yo1[i__ - 1] + u[8] * zo1[
		i__ - 1];
/* Computing 2nd power */
	r__1 = xx - xo2[i__ - 1];
/* Computing 2nd power */
	r__2 = yy - yo2[i__ - 1];
/* Computing 2nd power */
	r__3 = zz - zo2[i__ - 1];
	dis2[i__ - 1] = r__1 * r__1 + r__2 * r__2 + r__3 * r__3;
	gl2 += 1 / (dis2[i__ - 1] / d02 + 1);
    }
    gl2 /= (real) n_al__;
L21:
    j = 0;
    i__1 = n_al__;
    for (i__ = 1; i__ <= i__1; ++i__) {
	if (dis2[i__ - 1] <= d002) {
	    ++j;
	    r_1__[j * 3 - 3] = xo1[i__ - 1];
	    r_1__[j * 3 - 2] = yo1[i__ - 1];
	    r_1__[j * 3 - 1] = zo1[i__ - 1];
	    r_2__[j * 3 - 3] = xo2[i__ - 1];
	    r_2__[j * 3 - 2] = yo2[i__ - 1];
	    r_2__[j * 3 - 1] = zo2[i__ - 1];
	}
    }
    if (j <= 3) {
	d002 += (float).5;
	goto L21;
    }
    l = j;
    u3b_(w, r_1__, r_2__, &l, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
    gl3 = (float)0.;
    i__1 = n_al__;
    for (i__ = 1; i__ <= i__1; ++i__) {
	dis2[i__ - 1] = (float)0.;
	xx = t[0] + u[0] * xo1[i__ - 1] + u[3] * yo1[i__ - 1] + u[6] * zo1[
		i__ - 1];
	yy = t[1] + u[1] * xo1[i__ - 1] + u[4] * yo1[i__ - 1] + u[7] * zo1[
		i__ - 1];
	zz = t[2] + u[2] * xo1[i__ - 1] + u[5] * yo1[i__ - 1] + u[8] * zo1[
		i__ - 1];
/* Computing 2nd power */
	r__1 = xx - xo2[i__ - 1];
/* Computing 2nd power */
	r__2 = yy - yo2[i__ - 1];
/* Computing 2nd power */
	r__3 = zz - zo2[i__ - 1];
	dis2[i__ - 1] = r__1 * r__1 + r__2 * r__2 + r__3 * r__3;
	gl3 += 1 / (dis2[i__ - 1] / d02 + 1);
    }
    gl3 /= (real) n_al__;
    *gl = gl1;
    if (gl2 > *gl) {
	*gl = gl2;
    }
    if (gl3 > *gl) {
	*gl = gl3;
    }
    return 0;
} /* get_ngl__ */

/* ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* ccc */
/* ccc Subroutine for aligning the fragments based on GL-score matrix or */
/* ccc SSA+GL-score matrix. */
/* ccc */
/* ccc A variation Waterman-Eggert algorithm is applied to generate */
/* ccc suboptimal alignments after getting the best optimal alignments. */
/* ccc The step of generating suboptimal alignment: */
/* ccc 1. Recompute the F matrix with not allowing match for those position, */
/* ccc    which are aligned in the previous alignment. */
/* ccc 2. Backtrace the F matrix generating the alignment */
/* cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* Subroutine */ int fragdp_(integer *nfr1, integer *nfr2, real *smtx, real *
	gap, integer *ifrali, integer *ntot)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static real d__, h__;
    static integer i__, j;
    static real v;
    extern /* Subroutine */ int traceback_(integer *, integer *, real *, 
	    integer *, integer *, integer *, integer *, real *), 
	    recomputefmatrix_(integer *, integer *, real *, integer *, real *,
	     real *, integer *);
    static integer lf[1442401]	/* was [1201][1201] */, ii;
    static real val[1442401]	/* was [1201][1201] */, amax;
    static integer idir[1442401]	/* was [1201][1201] */, lcmap[1200];

/* initialize the F matrix */
    /* Parameter adjustments */
    ifrali -= 101;
    smtx -= 1201;

    /* Function Body */
    val[0] = (float)0.;
    i__1 = *nfr1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	idir[i__] = 0;
	val[i__] = (float)0.;
    }
    i__1 = *nfr2;
    for (j = 1; j <= i__1; ++j) {
	idir[j * 1201] = 0;
	val[j * 1201] = (float)0.;
	lcmap[j - 1] = -1;
    }
/* compute F matrix */
    i__1 = *nfr2;
    for (j = 1; j <= i__1; ++j) {
	i__2 = *nfr1;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    d__ = val[i__ - 1 + (j - 1) * 1201] + smtx[i__ + j * 1200];
	    h__ = val[i__ - 1 + j * 1201] + *gap;
	    v = val[i__ + (j - 1) * 1201] + *gap;
	    lf[i__ + j * 1201] = 0;
	    if (d__ >= h__ && d__ >= v) {
		val[i__ + j * 1201] = d__;
		idir[i__ + j * 1201] = 1;
	    } else {
		if (h__ >= v) {
		    val[i__ + j * 1201] = h__;
		    idir[i__ + j * 1201] = 2;
		} else {
		    val[i__ + j * 1201] = v;
		    idir[i__ + j * 1201] = 3;
		}
	    }
	}
    }
    amax = (float)0.;
    traceback_(nfr1, nfr2, val, idir, lf, lcmap, &c__1, &amax);
    ++(*ntot);
    i__1 = *nfr2;
    for (ii = 1; ii <= i__1; ++ii) {
	ifrali[*ntot + ii * 100] = lcmap[ii - 1];
	lcmap[ii - 1] = -1;
    }
    recomputefmatrix_(nfr1, nfr2, &smtx[1201], lf, val, gap, idir);
    traceback_(nfr1, nfr2, val, idir, lf, lcmap, &c__2, &amax);
    ++(*ntot);
    i__1 = *nfr2;
    for (ii = 1; ii <= i__1; ++ii) {
	ifrali[*ntot + ii * 100] = lcmap[ii - 1];
	lcmap[ii - 1] = -1;
    }
    recomputefmatrix_(nfr1, nfr2, &smtx[1201], lf, val, gap, idir);
    traceback_(nfr1, nfr2, val, idir, lf, lcmap, &c__3, &amax);
    ++(*ntot);
    i__1 = *nfr2;
    for (ii = 1; ii <= i__1; ++ii) {
	ifrali[*ntot + ii * 100] = lcmap[ii - 1];
	lcmap[ii - 1] = -1;
    }
    recomputefmatrix_(nfr1, nfr2, &smtx[1201], lf, val, gap, idir);
    traceback_(nfr1, nfr2, val, idir, lf, lcmap, &c__4, &amax);
    ++(*ntot);
    i__1 = *nfr2;
    for (ii = 1; ii <= i__1; ++ii) {
	ifrali[*ntot + ii * 100] = lcmap[ii - 1];
	lcmap[ii - 1] = -1;
    }
    return 0;
} /* fragdp_ */

/* cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* ccc Routine to filter the redundant fragment alignments */
/* cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* Subroutine */ int filter_(integer *ifrali, integer *ntot, integer *nfr2, 
	integer *nret, integer *jali)
{
    /* System generated locals */
    integer i__1, i__2, i__3;

    /* Local variables */
    static integer ii, jj, kk, nlc, istate[100];

    /* Parameter adjustments */
    jali -= 101;
    ifrali -= 101;

    /* Function Body */
    i__1 = *ntot;
    for (ii = 1; ii <= i__1; ++ii) {
	istate[ii - 1] = 1;
/* all are unique alignment */
    }
    i__1 = *ntot - 1;
    for (ii = 1; ii <= i__1; ++ii) {
	i__2 = *ntot;
	for (jj = ii + 1; jj <= i__2; ++jj) {
	    if (istate[jj - 1] == 1) {
		nlc = 0;
		i__3 = *nfr2;
		for (kk = 1; kk <= i__3; ++kk) {
		    if (ifrali[ii + kk * 100] == ifrali[jj + kk * 100]) {
			++nlc;
		    }
		}
		if (nlc == *nfr2) {
		    istate[jj - 1] = 0;
		}
	    }
	}
    }
    *nret = 0;
    i__1 = *ntot;
    for (ii = 1; ii <= i__1; ++ii) {
	if (istate[ii - 1] == 1) {
	    ++(*nret);
	    i__2 = *nfr2;
	    for (jj = 1; jj <= i__2; ++jj) {
		jali[*nret + jj * 100] = ifrali[ii + jj * 100];
	    }
	}
    }
    return 0;
} /* filter_ */

/* cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* ccc Subroutine for calculating the F matrix and returning the traceback matrix */
/* ccc */
/* cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* Subroutine */ int recomputefmatrix_(integer *nfr1, integer *nfr2, real *
	smtx, integer *lf, real *val, real *gap, integer *idir)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static real d__, h__;
    static integer i__, j;
    static real v;

/* initialize F matrix */
    /* Parameter adjustments */
    smtx -= 1201;

    /* Function Body */
    val[0] = (float)0.;
    i__1 = *nfr1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	idir[i__] = 0;
	val[i__] = (float)0.;
    }
    i__1 = *nfr2;
    for (j = 1; j <= i__1; ++j) {
	idir[j * 1201] = 0;
	val[j * 1201] = (float)0.;
    }
/* fill F matrix using a modified recursion relation */
    i__1 = *nfr2;
    for (j = 1; j <= i__1; ++j) {
	i__2 = *nfr1;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    if (lf[i__ + j * 1201] == 0) {
		d__ = val[i__ - 1 + (j - 1) * 1201] + smtx[i__ + j * 1200];
	    } else {
		d__ = (float)0.;
	    }
	    h__ = val[i__ - 1 + j * 1201] + *gap;
	    v = val[i__ + (j - 1) * 1201] + *gap;
	    if (d__ >= h__ && d__ >= v) {
		val[i__ + j * 1201] = d__;
		idir[i__ + j * 1201] = 1;
	    } else {
		if (h__ >= v) {
		    val[i__ + j * 1201] = h__;
		    idir[i__ + j * 1201] = 2;
		} else {
		    val[i__ + j * 1201] = v;
		    idir[i__ + j * 1201] = 3;
		}
	    }
	}
    }
    return 0;
} /* recomputefmatrix_ */

/* ccc Subroutine to traceback the filled F matrix */
/* ccc */
/* Subroutine */ int traceback_(integer *nfr1, integer *nfr2, real *val, 
	integer *idir, integer *lf, integer *lcmap, integer *iround, real *
	amax)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer i__, j, ii, jj;
    static real amax2;

/* Traceback GLOBAL optimal/suboptimal alignment with no penalty for end gaps */
/* find the highest score on the last row and column and start */
/* alignment from that position */
    /* Parameter adjustments */
    --lcmap;

    /* Function Body */
    i__ = *nfr1;
    j = *nfr2;
    amax2 = (float)0.;
    if (*iround == 1) {
	*amax = (float)4e4;
    }
    i__1 = *nfr1;
    for (ii = 1; ii <= i__1; ++ii) {
	if (val[ii + *nfr2 * 1201] > amax2 && val[ii + *nfr2 * 1201] < *amax) 
		{
	    amax2 = val[ii + *nfr2 * 1201];
	    i__ = ii;
	}
    }
    i__1 = *nfr2;
    for (jj = 1; jj <= i__1; ++jj) {
	if (val[*nfr1 + jj * 1201] > amax2 && val[*nfr1 + jj * 1201] < *amax) 
		{
	    amax2 = val[*nfr1 + jj * 1201];
	    j = jj;
	    i__ = *nfr1;
	}
    }
    if (*iround == 1) {
	*amax = amax2;
    }
    while(i__ > 0 && j > 0) {
	if (idir[i__ + j * 1201] == 1) {
	    lcmap[j] = i__;
	    lf[i__ + j * 1201] = 1;
	    --i__;
	    --j;
	} else if (idir[i__ + j * 1201] == 2) {
	    --i__;
	} else if (idir[i__ + j * 1201] == 3) {
	    --j;
	}
    }
    return 0;
} /* traceback_ */

/* *********************************************************************** */
/* * */
/* * The protein is divided into set of non-overlapping fragments of a */
/* * given length and we would comapre one fragment against all others */
/* * using cheap version of TM-score (GL-score). This score is finally */
/* * used for doing a repeated match DP to get many fragment alignment. */
/* * The aligned sets of fragment is joined to make the initial seed */
/* * alignment. The initial alignment is expanded with a routine of */
/* * extension using DP and TM-score. Now, we are using a new DP routine. */
/* * */
/* *********************************************************************** */
/* Subroutine */ int fragscan_(real *dx, real *dxs, integer *mapr, integer *
	irt, real *tmmax)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static real gap_open__;
    extern /* Subroutine */ int calbesttm_(real *, real *, integer *, integer 
	    *, integer *, integer *, integer *, integer *, integer *, real *);
    static integer ii;
    static real gl;
    static integer jj;
    static real fr, gap[4], ssa;
    static integer ipp, nfr1, nfr2, iali[120000]	/* was [100][1200] */,
	     nali;
    static real ssna, dpst[1440000]	/* was [1200][1200] */;
    static integer ntot;
    static real sspt[1440000]	/* was [1200][1200] */, smtx[1440000]	/* 
	    was [1200][1200] */;
    static integer iend1, iend2, lenfr;
    static real glmax, slmax, sspta[1440000]	/* was [1200][1200] */;
    extern /* Subroutine */ int fragdp_(integer *, integer *, real *, real *, 
	    integer *, integer *);
    static integer ifrali[120000]	/* was [100][1200] */;
    extern /* Subroutine */ int filter_(integer *, integer *, integer *, 
	    integer *, integer *);
    static integer minseq;
    static real slmaxn;
    static integer istart1, istart2;
    extern /* Subroutine */ int get_ngl__(integer *, integer *, integer *, 
	    integer *, integer *, real *, real *, real *);

/* max. no. of fragments */
/* max. no. of aligned fragments */
    /* Parameter adjustments */
    --mapr;

    /* Function Body */
    fr = (real) min(length_1.nseq1,length_1.nseq2) / (real) max(
	    length_1.nseq1,length_1.nseq2);
    minseq = min(length_1.nseq1,length_1.nseq2);
    if (minseq < 100) {
	ipp = 8;
    } else {
	ipp = 12;
    }
    lenfr = ipp;
    nfr1 = length_1.nseq1 / lenfr;
/* no. of fragments for seq1 */
    nfr2 = length_1.nseq2 / lenfr;
/* no. of fragments for seq2 */
    glmax = (float)0.;
    ntot = 0;
    slmax = (float)0.;
    slmaxn = (float)0.;
    i__1 = nfr2;
    for (ii = 1; ii <= i__1; ++ii) {
	istart2 = (ii - 1) * lenfr + 1;
	iend2 = istart2 + lenfr - 1;
	if (ii == nfr2) {
	    iend2 = length_1.nseq2;
	}
	i__2 = nfr1;
	for (jj = 1; jj <= i__2; ++jj) {
	    istart1 = (jj - 1) * lenfr + 1;
	    iend1 = istart1 + lenfr - 1;
	    if (jj == nfr1) {
		iend1 = length_1.nseq1;
	    }
	    get_ngl__(&istart1, &iend1, &istart2, &iend2, &lenfr, &gl, &ssa, &
		    ssna);
	    if (gl > glmax) {
		glmax = gl;
	    }
	    if (ii != nfr2 && jj != nfr1) {
		if (ssa > slmax) {
		    slmax = ssa;
		}
		if (ssna > slmaxn) {
		    slmaxn = ssna;
		}
	    }
	    dpst[jj + ii * 1200 - 1201] = gl;
	    sspt[jj + ii * 1200 - 1201] = ssa;
	    sspta[jj + ii * 1200 - 1201] = ssna;
	    ++ntot;
	}
    }
    gap[0] = (float)-.6;
    gap[1] = (float)-.1;
    gap[2] = (float)0.;
    *tmmax = (float)0.;
    ntot = 0;
    i__1 = nfr1;
    for (ii = 1; ii <= i__1; ++ii) {
	i__2 = nfr2;
	for (jj = 1; jj <= i__2; ++jj) {
	    smtx[ii + jj * 1200 - 1201] = dpst[ii + jj * 1200 - 1201] / glmax;
	}
    }
    for (ipp = 1; ipp <= 3; ++ipp) {
	gap_open__ = gap[ipp - 1];
	fragdp_(&nfr1, &nfr2, smtx, &gap_open__, ifrali, &ntot);
/* returns ntot */
    }
    if (slmax < (float).3) {
	i__1 = nfr1;
	for (ii = 1; ii <= i__1; ++ii) {
	    i__2 = nfr2;
	    for (jj = 1; jj <= i__2; ++jj) {
		sspt[ii + jj * 1200 - 1201] = sspta[ii + jj * 1200 - 1201];
	    }
	}
	slmax = slmaxn;
    }
    i__1 = nfr1;
    for (ii = 1; ii <= i__1; ++ii) {
	i__2 = nfr2;
	for (jj = 1; jj <= i__2; ++jj) {
	    smtx[ii + jj * 1200 - 1201] = sspt[ii + jj * 1200 - 1201] / slmax 
		    * (float).5 + dpst[ii + jj * 1200 - 1201] / glmax * (
		    float).5;
	}
    }
    for (ipp = 1; ipp <= 3; ++ipp) {
	gap_open__ = gap[ipp - 1];
	fragdp_(&nfr1, &nfr2, smtx, &gap_open__, ifrali, &ntot);
/* returns ntot */
    }
    filter_(ifrali, &ntot, &nfr2, &nali, iali);
    calbesttm_(dx, dxs, &nfr1, &nfr2, &lenfr, &nali, iali, irt, &mapr[1], 
	    tmmax);
    return 0;
} /* fragscan_ */

/* *********************************************************************** */
/* ****          Get the alignment from the fragments and do heuristic */
/* ****          iteration */
/* *********************************************************************** */
/* Subroutine */ int calbesttm_(real *dx, real *dxs, integer *nfr1, integer *
	nfr2, integer *nlen, integer *ntot, integer *ifrali, integer *irt, 
	integer *mapr, real *tmmax)
{
    /* System generated locals */
    integer i__1, i__2, i__3;

    /* Local variables */
    static integer ii, jj;
    extern /* Subroutine */ int fillinvmap_(integer *);
    static integer ifr1, ifr2, iali, itmp, iend1, iend2;
    extern /* Subroutine */ int caltmsc_fast__(real *, real *, integer *, 
	    real *, integer *, real *);
    static integer lcmap[1200];
    static real tminp;
    static integer invmap[3000];
    static real b1tmmax;
    static integer istart1, istart2;
    extern /* Subroutine */ int caltmsc_(real *, real *, integer *, real *, 
	    integer *, real *);
    static integer invmapr[3000];

    /* Parameter adjustments */
    --mapr;
    ifrali -= 101;

    /* Function Body */
    *tmmax = (float)0.;
    i__1 = *ntot;
    for (iali = 1; iali <= i__1; ++iali) {
	i__2 = *nfr2;
	for (ii = 1; ii <= i__2; ++ii) {
	    lcmap[ii - 1] = ifrali[iali + ii * 100];
	}
	fillinvmap_(invmap);
	i__2 = *nfr2;
	for (ii = 1; ii <= i__2; ++ii) {
	    ifr1 = lcmap[ii - 1];
	    ifr2 = ii;
	    if (ifr1 > 0) {
		istart1 = (ifr1 - 1) * *nlen + 1;
		istart2 = (ifr2 - 1) * *nlen + 1;
		iend1 = istart1 + *nlen - 1;
		iend2 = istart2 + *nlen - 1;
		if (ifr1 == *nfr1) {
		    iend1 = length_1.nseq1;
		}
		if (ifr2 == *nfr2) {
		    iend2 = length_1.nseq2;
		}
		if (iend1 - istart1 < iend2 - istart2) {
		    iend2 = iend1 - istart1 + istart2;
		}
		itmp = istart1;
		i__3 = iend2;
		for (jj = istart2; jj <= i__3; ++jj) {
		    invmap[jj - 1] = itmp;
		    ++itmp;
		}
	    }
	}
	tminp = *tmmax;
	if (*irt == 0) {
	    caltmsc_(dx, dxs, invmap, &tminp, invmapr, &b1tmmax);
	} else if (*irt == 1) {
	    caltmsc_fast__(dx, dxs, invmap, &tminp, invmapr, &b1tmmax);
	}
	if (b1tmmax > *tmmax) {
	    i__2 = length_1.nseq2;
	    for (ii = 1; ii <= i__2; ++ii) {
		mapr[ii] = invmapr[ii - 1];
	    }
	    *tmmax = b1tmmax;
	}
    }
/* for total no. of alignments */
    return 0;
} /* calbesttm_ */

/* ******************************************************** */
/* *      Routine for slow calculation of best alignment */
/* *      Scans many alignments!! */
/* ******************************************************** */
/* Subroutine */ int caltmsc_(real *dx, real *dxs, integer *map, real *tmch, 
	integer *mapr, real *tmscm)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static real gap_open__;
    static integer invmap_i__[3000];
    static real tminp_lc__;
    extern /* Subroutine */ int make_iter__(real *, real *, real *, integer *,
	     integer *, real *, integer *), get_score__(real *, real *, 
	    integer *, real *, real *);
    static integer ii;
    extern /* Subroutine */ int dp_(real *, real *, integer *, real *);
    static real tm, gap[2], ttm;
    extern /* Subroutine */ int get_initial3__(real *, integer *, real *, 
	    real *);
    static integer iend;
    static real score[9000000]	/* was [3000][3000] */, dpout, scorea[9000000]
	    	/* was [3000][3000] */, scoret[9000000]	/* was [3000][3000] */
	    ;
    static integer istart;
    extern /* Subroutine */ int getbest_(real *, integer *, real *, integer *)
	    ;
    static integer invmapr[3000];

    /* Parameter adjustments */
    --mapr;
    --map;

    /* Function Body */
    gap[0] = (float)-1.;
    gap[1] = (float)0.;
    *tmscm = (float)0.;
    get_initial3__(dx, &map[1], scoret, scorea);
    tminp_lc__ = *tmch;
    istart = 1;
    iend = 2;
    if (*tmch > (float).5) {
	iend = 1;
    }
    i__1 = iend;
    for (ii = istart; ii <= i__1; ++ii) {
	gap_open__ = gap[ii - 1];
	dp_(scorea, &gap_open__, invmap_i__, &dpout);
	get_score__(dx, dxs, invmap_i__, score, &tm);
	ttm = tm;
	if (ttm > tminp_lc__) {
	    make_iter__(dx, dxs, score, &c__12, invmap_i__, &ttm, invmapr);
	    getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	    if (*tmscm > tminp_lc__) {
		tminp_lc__ = *tmscm;
	    }
	} else {
	    make_iter__(dx, dxs, score, &c__7, invmap_i__, &ttm, invmapr);
	    getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	    if (*tmscm > tminp_lc__) {
		tminp_lc__ = *tmscm;
	    }
	}
    }
    if (*tmscm > tminp_lc__) {
	tminp_lc__ = *tmscm;
    }
    if (tminp_lc__ > (float).5) {
	istart = 2;
    }
    i__1 = iend;
    for (ii = istart; ii <= i__1; ++ii) {
	gap_open__ = gap[ii - 1];
	dp_(scoret, &gap_open__, invmap_i__, &dpout);
	get_score__(dx, dxs, invmap_i__, score, &tm);
	ttm = tm;
	if (ttm > *tmscm) {
	    make_iter__(dx, dxs, score, &c__12, invmap_i__, &ttm, invmapr);
	    getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	} else {
	    make_iter__(dx, dxs, score, &c__7, invmap_i__, &ttm, invmapr);
	    getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	}
    }
    if (*tmscm > tminp_lc__) {
	tminp_lc__ = *tmscm;
    }
    if (tminp_lc__ < (float).5) {
	get_score__(dx, dxs, &map[1], scorea, &tm);
	for (ii = 2; ii <= 2; ++ii) {
	    gap_open__ = gap[ii - 1];
	    dp_(scorea, &gap_open__, invmap_i__, &dpout);
	    get_score__(dx, dxs, invmap_i__, score, &tm);
	    ttm = tm;
	    if (ttm > *tmscm) {
		make_iter__(dx, dxs, score, &c__12, invmap_i__, &ttm, invmapr)
			;
		getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	    } else {
		make_iter__(dx, dxs, score, &c__6, invmap_i__, &ttm, invmapr);
		getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	    }
	}
    }
    return 0;
} /* caltmsc_ */

/* ******************************************************** */
/* *** General routine to fill the starting alignment !! */
/* ******************************************************** */
/* Subroutine */ int fillinvmap_(integer *invmapr)
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer jj;

    /* Parameter adjustments */
    --invmapr;

    /* Function Body */
    i__1 = length_1.nseq2;
    for (jj = 1; jj <= i__1; ++jj) {
	invmapr[jj] = -1;
    }
    return 0;
} /* fillinvmap_ */

/* ******************************************************** */
/* *      Routine for fast calculation of best alignment */
/* *      Scans less number of alignments!! */
/* ******************************************************** */
/* Subroutine */ int caltmsc_fast__(real *dx, real *dxs, integer *map, real *
	tmch, integer *mapr, real *tmscm)
{
    static real gap_open__;
    static integer invmap_i__[3000];
    static real tminp_lc__;
    extern /* Subroutine */ int make_iter__(real *, real *, real *, integer *,
	     integer *, real *, integer *), get_score__(real *, real *, 
	    integer *, real *, real *);
    static integer ii;
    extern /* Subroutine */ int dp_(real *, real *, integer *, real *);
    static real tm, gap[2], ttm;
    extern /* Subroutine */ int get_initial3__(real *, integer *, real *, 
	    real *);
    static real score[9000000]	/* was [3000][3000] */, dpout, scorea[9000000]
	    	/* was [3000][3000] */, scoret[9000000]	/* was [3000][3000] */
	    ;
    extern /* Subroutine */ int getbest_(real *, integer *, real *, integer *)
	    ;
    static integer invmapr[3000];

    /* Parameter adjustments */
    --mapr;
    --map;

    /* Function Body */
    gap[0] = (float)-1.;
    gap[1] = (float)0.;
    *tmscm = (float)0.;
    get_initial3__(dx, &map[1], scoret, scorea);
    tminp_lc__ = *tmch;
    for (ii = 1; ii <= 1; ++ii) {
	gap_open__ = gap[ii - 1];
	dp_(scorea, &gap_open__, invmap_i__, &dpout);
	get_score__(dx, dxs, invmap_i__, score, &tm);
	ttm = tm;
	if (ttm > tminp_lc__) {
	    make_iter__(dx, dxs, score, &c__14, invmap_i__, &ttm, invmapr);
	    getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	    if (*tmscm > tminp_lc__) {
		tminp_lc__ = *tmscm;
	    }
	} else {
	    make_iter__(dx, dxs, score, &c__7, invmap_i__, &ttm, invmapr);
	    getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	    if (*tmscm > tminp_lc__) {
		tminp_lc__ = *tmscm;
	    }
	}
    }
    if (tminp_lc__ < *tmscm) {
	tminp_lc__ = *tmscm;
    }
    for (ii = 2; ii <= 2; ++ii) {
	gap_open__ = gap[ii - 1];
	dp_(scoret, &gap_open__, invmap_i__, &dpout);
	get_score__(dx, dxs, invmap_i__, score, &tm);
	ttm = tm;
	if (ttm > *tmscm) {
	    make_iter__(dx, dxs, score, &c__14, invmap_i__, &ttm, invmapr);
	    getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	} else {
	    make_iter__(dx, dxs, score, &c__7, invmap_i__, &ttm, invmapr);
	    getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	}
    }
    if (tminp_lc__ < *tmscm) {
	tminp_lc__ = *tmscm;
    }
    if (tminp_lc__ < (float).5) {
	get_score__(dx, dxs, &map[1], scorea, &tm);
	for (ii = 2; ii <= 2; ++ii) {
	    gap_open__ = gap[ii - 1];
	    dp_(scorea, &gap_open__, invmap_i__, &dpout);
	    get_score__(dx, dxs, invmap_i__, score, &tm);
	    ttm = tm;
	    if (ttm > *tmscm) {
		make_iter__(dx, dxs, score, &c__14, invmap_i__, &ttm, invmapr)
			;
		getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	    } else {
		make_iter__(dx, dxs, score, &c__7, invmap_i__, &ttm, invmapr);
		getbest_(&ttm, invmapr, tmscm, &mapr[1]);
	    }
	}
    }
    return 0;
} /* caltmsc_fast__ */

/* ***************************************************************** */
/* ccc Subroutines for Fr-TM-align */
/* ccc get_initial3,dp,make_iter,get_score1,get_score */
/* ************************************************************ */
/* * 	DP routine (score matrix, gap open, alignment) */
/* *  returns invmap_i */
/* * Fix: In the Iteration routine if the number of residues aligned is */
/* *      less than 5 residues the method aborts checking for any */
/* *      improvement in the alignment. */
/* ************************************************************ */
/* Subroutine */ int dp_(real *score, real *gap_open__, integer *invmap_i__, 
	real *dpout)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static real d__, h__;
    static integer i__, j;
    static real v;
    static integer ii, jj;
    static logical1 dir[9006001]	/* was [3001][3001] */;
    static real val[9006001]	/* was [3001][3001] */;
    static integer icho;
    static real amax;
    static integer minseq;

/* no. of residues */
/* ccc initialize matrix */
    /* Parameter adjustments */
    --invmap_i__;
    score -= 3001;

    /* Function Body */
    i__1 = length_1.nseq2;
    for (ii = 1; ii <= i__1; ++ii) {
	invmap_i__[ii] = -1;
    }
    val[0] = (float)0.;
    i__1 = length_1.nseq1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	dir[i__] = FALSE_;
	val[i__] = (float)0.;
    }
    i__1 = length_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	dir[j * 3001] = FALSE_;
	val[j * 3001] = (float)0.;
	invmap_i__[j] = -1;
    }
/* ccc fill the matrix and path */
    i__1 = length_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	i__2 = length_1.nseq1;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    d__ = val[i__ - 1 + (j - 1) * 3001] + score[i__ + j * 3000];
	    h__ = val[i__ - 1 + j * 3001];
	    v = val[i__ + (j - 1) * 3001];
	    if (dir[i__ - 1 + j * 3001]) {
		h__ += *gap_open__;
	    }
	    if (dir[i__ + (j - 1) * 3001]) {
		v += *gap_open__;
	    }
	    if (d__ >= h__ && d__ >= v) {
		dir[i__ + j * 3001] = TRUE_;
		val[i__ + j * 3001] = d__;
	    } else {
		dir[i__ + j * 3001] = FALSE_;
		if (v >= h__) {
		    val[i__ + j * 3001] = v;
		} else {
		    val[i__ + j * 3001] = h__;
		}
	    }
	}
    }
/* ccc   extract the alignment: */
    i__ = length_1.nseq1;
    j = length_1.nseq2;
    amax = (float)0.;
    icho = 0;
    minseq = length_1.nseq1;
    if (minseq < length_1.nseq2) {
	icho = 1;
    }
    if (icho == 1) {
	for (jj = length_1.nseq2; jj >= 1; --jj) {
	    if (val[length_1.nseq1 + jj * 3001] > amax) {
		amax = val[length_1.nseq1 + jj * 3001];
		j = jj;
	    }
	}
    } else {
	for (ii = length_1.nseq1; ii >= 1; --ii) {
	    if (val[ii + length_1.nseq2 * 3001] > amax) {
		amax = val[ii + length_1.nseq2 * 3001];
		i__ = ii;
	    }
	}
    }
    while(i__ > 0 && j > 0) {
	if (dir[i__ + j * 3001]) {
	    invmap_i__[j] = i__;
	    --i__;
	    --j;
	} else {
	    h__ = val[i__ - 1 + j * 3001];
	    v = val[i__ + (j - 1) * 3001];
	    if (dir[i__ - 1 + j * 3001]) {
		h__ += *gap_open__;
	    }
	    if (dir[i__ + (j - 1) * 3001]) {
		v += *gap_open__;
	    }
	    if (v >= h__) {
		--j;
	    } else {
		--i__;
	    }
	}
    }
    j = length_1.nseq2;
    while(invmap_i__[j] < 1) {
	--j;
    }
    *dpout = val[invmap_i__[j] + j * 3001];
    return 0;
} /* dp_ */

/* ************************************************************* */
/* *  a kind of mixing of two previous alignments. */
/* *  Takes the alignment and retuns the alignment!! */
/* ************************************************************* */
/* Subroutine */ int get_initial3__(real *d0, integer *invmapi, real *score, 
	real *scorer)
{
    /* System generated locals */
    integer i__1, i__2;

    /* Local variables */
    static integer invmap_i__[3000], i__, j;
    extern /* Subroutine */ int get_score1__(real *, integer *, real *);

/* no. of residues */
/* ccc  score matrix */
    /* Parameter adjustments */
    scorer -= 3001;
    score -= 3001;
    --invmapi;

    /* Function Body */
    i__1 = length_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	invmap_i__[j - 1] = invmapi[j];
    }
    get_score1__(d0, invmap_i__, &score[3001]);
/* get score(i,j) using RMSD martix */
    i__1 = length_1.nseq1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	i__2 = length_1.nseq2;
	for (j = 1; j <= i__2; ++j) {
	    if (secstr_1.isec[i__ - 1] == secstr_1.jsec[j - 1]) {
		scorer[i__ + j * 3000] = score[i__ + j * 3000] + (float).5;
	    } else {
		scorer[i__ + j * 3000] = score[i__ + j * 3000];
	    }
	}
    }
    return 0;
} /* get_initial3__ */

/* ***************************************************************** */
/* *  with invmap_i(i) calculate score(i,j) using RMSD rotation */
/* ***************************************************************** */
/* Subroutine */ int get_score1__(real *dx, integer *invmapi, real *score)
{
    /* Initialized data */

    static doublereal w[3000] = { 1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1. };

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2, r__3;

    /* Local variables */
    static integer i__, j;
    static doublereal t[3], u[9]	/* was [3][3] */;
    static real d01, d02, dd, xx, yy, zz;
    static doublereal r_1__[9000]	/* was [3][3000] */, r_2__[9000]	
	    /* was [3][3000] */;
    extern /* Subroutine */ int u3b_(doublereal *, doublereal *, doublereal *,
	     integer *, integer *, doublereal *, doublereal *, doublereal *, 
	    integer *);
    static integer ier;
    static doublereal rms;
    static integer n_al__;
    static real d0_min__;

/* no. of residues */
/* ccc  RMSD: */
/* armsd is real */
    /* Parameter adjustments */
    score -= 3001;
    --invmapi;

    /* Function Body */
/* ccc  calculate RMSD between aligned structures and rotate the structures --> */
    n_al__ = 0;
    i__1 = length_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	i__ = invmapi[j];
/* j aligned to i */
	if (i__ > 0) {
	    ++n_al__;
	    r_1__[n_al__ * 3 - 3] = coord_1.xa[i__ * 3 - 3];
/* for rotation matrix */
	    r_1__[n_al__ * 3 - 2] = coord_1.xa[i__ * 3 - 2];
	    r_1__[n_al__ * 3 - 1] = coord_1.xa[i__ * 3 - 1];
	    r_2__[n_al__ * 3 - 3] = coord_1.xa[(j + 3000) * 3 - 3];
	    r_2__[n_al__ * 3 - 2] = coord_1.xa[(j + 3000) * 3 - 2];
	    r_2__[n_al__ * 3 - 1] = coord_1.xa[(j + 3000) * 3 - 1];
	}
    }
/* ccc  calculate score matrix score(i,j)------------------> */
    u3b_(w, r_1__, r_2__, &n_al__, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
    d0_min__ = (float).5;
    d01 = *dx + (float)1.5;
    if (d01 < d0_min__) {
	d01 = d0_min__;
    }
/* Computing 2nd power */
    r__1 = d01;
    d02 = r__1 * r__1;
    i__1 = length_1.nseq1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xx = t[0] + u[0] * coord_1.xa[i__ * 3 - 3] + u[3] * coord_1.xa[i__ * 
		3 - 2] + u[6] * coord_1.xa[i__ * 3 - 1];
	yy = t[1] + u[1] * coord_1.xa[i__ * 3 - 3] + u[4] * coord_1.xa[i__ * 
		3 - 2] + u[7] * coord_1.xa[i__ * 3 - 1];
	zz = t[2] + u[2] * coord_1.xa[i__ * 3 - 3] + u[5] * coord_1.xa[i__ * 
		3 - 2] + u[8] * coord_1.xa[i__ * 3 - 1];
	i__2 = length_1.nseq2;
	for (j = 1; j <= i__2; ++j) {
/* Computing 2nd power */
	    r__1 = xx - coord_1.xa[(j + 3000) * 3 - 3];
/* Computing 2nd power */
	    r__2 = yy - coord_1.xa[(j + 3000) * 3 - 2];
/* Computing 2nd power */
	    r__3 = zz - coord_1.xa[(j + 3000) * 3 - 1];
	    dd = r__1 * r__1 + r__2 * r__2 + r__3 * r__3;
	    score[i__ + j * 3000] = 1 / (dd / d02 + 1);
	}
    }
    return 0;
} /* get_score1__ */

/* ***************************************************************** */
/* *  with invmap_i(i) calculate TM-score and martix score(i,j) for rotation */
/* *  isearch takes 3 values for 3 different kind of TM-score calculation */
/* *  isearch=1, searching with long jumps of 40 residues in TMsearch routine */
/* ***************************************************************** */
/* Subroutine */ int get_score__(real *d0, real *d0_s__, integer *invmap_i__, 
	real *score, real *tm)
{
    /* Initialized data */

    static doublereal w[3000] = { 1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1. };

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2, r__3;

    /* Local variables */
    static real d0_input__;
    extern /* Subroutine */ int tmsearch_(real *, real *, integer *, real *, 
	    real *, real *, integer *, integer *, real *, real *, real *, 
	    integer *, real *, real *, integer *, integer *);
    static integer i__, j;
    static doublereal t[3], u[9]	/* was [3][3] */;
    static real d02, dd, xx, yy, zz;
    static doublereal r_1__[9000]	/* was [3][3000] */, r_2__[9000]	
	    /* was [3][3000] */;
    extern /* Subroutine */ int u3b_(doublereal *, doublereal *, doublereal *,
	     integer *, integer *, doublereal *, doublereal *, doublereal *, 
	    integer *);
    static integer ier;
    static doublereal rms;
    static real xtm1[3000], ytm1[3000], ztm1[3000], xtm2[3000], ytm2[3000], 
	    ztm2[3000];
    static integer n_al__;
    static real anseq;
    static integer lcomm;
    static real rcomm;
    static integer isearch;

/* no. of residues */
/* ccc  RMSD: */
/* armsd is real */
    /* Parameter adjustments */
    score -= 3001;
    --invmap_i__;

    /* Function Body */
/* ccc  calculate RMSD between aligned structures and rotate the structures --> */
    anseq = (real) min(length_1.nseq1,length_1.nseq2);
/* for normalization of TM-score */
/* Computing 2nd power */
    r__1 = *d0;
    d02 = r__1 * r__1;
    n_al__ = 0;
    i__1 = length_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	i__ = invmap_i__[j];
/* j aligned to i */
	if (i__ > 0) {
	    ++n_al__;
	    xtm1[n_al__ - 1] = coord_1.xa[i__ * 3 - 3];
/* for TM-score */
	    ytm1[n_al__ - 1] = coord_1.xa[i__ * 3 - 2];
	    ztm1[n_al__ - 1] = coord_1.xa[i__ * 3 - 1];
	    xtm2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 3];
	    ytm2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 2];
	    ztm2[n_al__ - 1] = coord_1.xa[(j + 3000) * 3 - 1];
/* cc   for rotation matrix: */
	    r_1__[n_al__ * 3 - 3] = coord_1.xa[i__ * 3 - 3];
	    r_1__[n_al__ * 3 - 2] = coord_1.xa[i__ * 3 - 2];
	    r_1__[n_al__ * 3 - 1] = coord_1.xa[i__ * 3 - 1];
	}
    }
    d0_input__ = *d0;
    isearch = 1;
/* VERY IMP. determines way TM-score is calculate and reported ! */
    tmsearch_(&d0_input__, d0_s__, &n_al__, xtm1, ytm1, ztm1, n1n2_1.n1, &
	    n_al__, xtm2, ytm2, ztm2, n1n2_1.n2, tm, &rcomm, &lcomm, &isearch)
	    ;
/* simplified search engine */
    *tm /= anseq;
/* ccc output score matrix score(i,j) */
/* ccc protein 1 or r_1 is need to rotated since in previous the rotation is for aligned subset!! */
    i__1 = n_al__;
    for (i__ = 1; i__ <= i__1; ++i__) {
	r_2__[i__ * 3 - 3] = xtm1[i__ - 1];
	r_2__[i__ * 3 - 2] = ytm1[i__ - 1];
	r_2__[i__ * 3 - 1] = ztm1[i__ - 1];
    }
    u3b_(w, r_1__, r_2__, &n_al__, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
    i__1 = length_1.nseq1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xx = t[0] + u[0] * coord_1.xa[i__ * 3 - 3] + u[3] * coord_1.xa[i__ * 
		3 - 2] + u[6] * coord_1.xa[i__ * 3 - 1];
	yy = t[1] + u[1] * coord_1.xa[i__ * 3 - 3] + u[4] * coord_1.xa[i__ * 
		3 - 2] + u[7] * coord_1.xa[i__ * 3 - 1];
	zz = t[2] + u[2] * coord_1.xa[i__ * 3 - 3] + u[5] * coord_1.xa[i__ * 
		3 - 2] + u[8] * coord_1.xa[i__ * 3 - 1];
	i__2 = length_1.nseq2;
	for (j = 1; j <= i__2; ++j) {
/* Computing 2nd power */
	    r__1 = xx - coord_1.xa[(j + 3000) * 3 - 3];
/* Computing 2nd power */
	    r__2 = yy - coord_1.xa[(j + 3000) * 3 - 2];
/* Computing 2nd power */
	    r__3 = zz - coord_1.xa[(j + 3000) * 3 - 1];
	    dd = r__1 * r__1 + r__2 * r__2 + r__3 * r__3;
	    score[i__ + j * 3000] = 1 / (dd / d02 + 1);
	}
    }
    return 0;
} /* get_score__ */

/* ***************************************************************** */
/* * Make iteration for a given alignment with two gap opening's */
/* * */
/* ***************************************************************** */
/* Subroutine */ int make_iter__(real *d0, real *d0_s__, real *score, integer 
	*niter, integer *invmapi, real *atm, integer *invmapr)
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1;

    /* Local variables */
    static real gap_open__;
    static integer invmap_i__[3000], j;
    extern /* Subroutine */ int get_score__(real *, real *, integer *, real *,
	     real *);
    static integer ilc_count__, id;
    extern /* Subroutine */ int dp_(real *, real *, integer *, real *);
    static integer ik;
    static real tm, gap[10], diff;
    static integer ngap, i_gap__;
    static real dpout, tm_old__;
    static integer invmap[3000];

    /* Parameter adjustments */
    --invmapr;
    --invmapi;
    score -= 3001;

    /* Function Body */
    ngap = 2;
    gap[0] = (float)-.6;
    gap[1] = (float)0.;
/* ccc copy the alignment */
    i__1 = length_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	invmap[j - 1] = invmapi[j];
    }
    i__1 = ngap;
    for (i_gap__ = 1; i_gap__ <= i__1; ++i_gap__) {
	gap_open__ = gap[i_gap__ - 1];
	i__2 = *niter;
	for (id = 1; id <= i__2; ++id) {
	    dp_(&score[3001], &gap_open__, invmap_i__, &dpout);
/* returns invmap_i */
	    ilc_count__ = 0;
	    i__3 = length_1.nseq2;
	    for (ik = 1; ik <= i__3; ++ik) {
		if (invmap_i__[ik - 1] > 0) {
		    ++ilc_count__;
		}
	    }
	    if (ilc_count__ <= 5) {
		goto L33;
	    }
	    get_score__(d0, d0_s__, invmap_i__, &score[3001], &tm);
/* refills the score matrix using invmap_i */
	    if (tm > *atm) {
		*atm = tm;
		i__3 = length_1.nseq2;
		for (j = 1; j <= i__3; ++j) {
		    invmap[j - 1] = invmap_i__[j - 1];
		}
	    }
	    if (id > 1) {
		diff = (r__1 = tm - tm_old__, dabs(r__1));
		if (diff < (float)1e-6) {
		    goto L33;
		}
	    }
	    tm_old__ = tm;
/* L222: */
	}
L33:
/* L111: */
	;
    }
    i__1 = length_1.nseq2;
    for (j = 1; j <= i__1; ++j) {
	invmapr[j] = invmap[j - 1];
    }
    return 0;
} /* make_iter__ */

/* ccc Subroutines for TM-align */
/* ccc TMsearch, cal_tmscore */
/* Subroutine */ int tmsearch_(real *dx, real *dxs, integer *l1, real *x1, 
	real *y1, real *z1, integer *n1, integer *l2, real *x2, real *y2, 
	real *z2, integer *n2, real *tm, real *rcomm, integer *lcomm, integer 
	*isearch)
{
    /* Initialized data */

    static doublereal w[3000] = { 1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,
	    1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1.,1. };

    /* System generated locals */
    integer i__1, i__2, i__3, i__4;

    /* Builtin functions */
    integer pow_ii(integer *, integer *);
    double sqrt(doublereal);

    /* Local variables */
    static real d0_search__, d__;
    static integer i__, j, k, m;
    static doublereal t[3], u[9]	/* was [3][3] */;
    static integer l_ini_min__;
    static real d0, score_max__;
    static integer ka, il, ll;
    static real xa[3000], ya[3000], za[3000];
    static integer it, ka0;
    static doublereal r_1__[9000]	/* was [3][3000] */, r_2__[9000]	
	    /* was [3][3000] */;
    static integer n_init_max__, il0[3000];
    extern /* Subroutine */ int u3b_(doublereal *, doublereal *, doublereal *,
	     integer *, integer *, doublereal *, doublereal *, doublereal *, 
	    integer *);
    static integer ier, neq;
    static doublereal rms;
    extern /* Subroutine */ int cal_tmscore__(real *, real *, integer *, 
	    logical *, doublereal *, integer *, integer *);
    static integer n_it__, i_ali__[3000], k_ali__[3000], n_ali__, l_ini__[100]
	    ;
    static real armsd;
    static integer nseqa, nseqb, n_cut__;
    static doublereal score;
    static integer ijump;
    static logical nstat;
    static integer k_ali0__[3000];
    static real d0_min__;
    static integer il_max__, i_init__, l_init__, n_init__, i_shift__, 
	    n_shift__;

/* for cal_tmscore routine */
/* shared in next subroutine */
/* cc   RMSD: */
/* armsd is real */
    /* Parameter adjustments */
    --n2;
    --z2;
    --y2;
    --x2;
    --n1;
    --z1;
    --y1;
    --x1;

    /* Function Body */
/* ccc  convert input data. Special case here of L1.eq.L2 */
    nstat = FALSE_;
/* for including residues for TM-score calculation */
/* used in cal_tmscore routine for decision */
    nseqa = *l1;
    nseqb = *l2;
    i__1 = nseqa;
    for (i__ = 1; i__ <= i__1; ++i__) {
	xa[i__ - 1] = x1[i__];
	ya[i__ - 1] = y1[i__];
	za[i__ - 1] = z1[i__];
	stru_1.xb[i__ - 1] = x2[i__];
	stru_1.yb[i__ - 1] = y2[i__];
	stru_1.zb[i__ - 1] = z2[i__];
	align_1.ia[i__ - 1] = i__;
	align_1.ib[i__ - 1] = i__;
    }
    n_ali__ = *l1;
/* number of aligned residues */
    *lcomm = *l1;
/* ccc d0 parameters */
    d0_min__ = (float).5;
    d0 = *dx;
    if (d0 < d0_min__) {
	d0 = d0_min__;
    }
    d0_search__ = *dxs;
/* ccc  iterative parameters -----> */
    n_it__ = 20;
/* maximum number of iterations */
    n_init_max__ = 6;
/* maximum number of L_init */
    n_init__ = 0;
/* number of fragments L/2**(n) */
    l_ini_min__ = 4;
    if (n_ali__ < 4) {
	l_ini_min__ = n_ali__;
    }
    i__1 = n_init_max__ - 1;
    for (i__ = 1; i__ <= i__1; ++i__) {
	++n_init__;
	i__2 = n_init__ - 1;
	l_ini__[n_init__ - 1] = n_ali__ / pow_ii(&c__2, &i__2);
	if (l_ini__[n_init__ - 1] <= l_ini_min__) {
	    l_ini__[n_init__ - 1] = l_ini_min__;
	    goto L402;
	}
    }
    ++n_init__;
    l_ini__[n_init__ - 1] = l_ini_min__;
L402:
/* ccc  find the maximum score starting from local structures superposition */
    score_max__ = (float)-1.;
/* TM-score */
    if (*isearch == 1) {
	ijump = 40;
	if (min(length_1.nseq1,length_1.nseq2) <= 80) {
	    ijump = 30;
	}
    }
    if (*isearch >= 2) {
	ijump = 1;
    }
    if (*isearch == 1 || *isearch == 2) {
	nstat = TRUE_;
    }
    i__1 = n_init__;
    for (i_init__ = 1; i_init__ <= i__1; ++i_init__) {
	l_init__ = l_ini__[i_init__ - 1];
/* Length to be used for scanning L */
	il_max__ = n_ali__ - l_init__ + 1;
/*      if (isearch.gt.2) write(*,*)iL_max,score_max,d0_search,d0 */
/* maximum number of scans (Nali-L+1), shifting by one residue */
	if (*isearch == 1) {
	    k = 0;
	    i__2 = il_max__;
	    i__3 = ijump;
	    for (i__ = 1; i__3 < 0 ? i__ >= i__2 : i__ <= i__2; i__ += i__3) {
/* this is the for the real quick result */
		++k;
/* when isearch.eq.1 */
		il0[k - 1] = i__;
/* storing the starting residue for scan */
	    }
	    if (il0[k - 1] < il_max__) {
		++k;
		il0[k - 1] = il_max__;
/* fixing the last run, quite arbitarary!! */
	    }
	    n_shift__ = k;
/* number of shifts */
	} else {
	    n_shift__ = il_max__;
	}
	i__3 = n_shift__;
	for (i_shift__ = 1; i_shift__ <= i__3; ++i_shift__) {
	    if (*isearch == 1) {
		il = il0[i_shift__ - 1];
	    } else {
		il = i_shift__;
	    }
	    ll = 0;
	    ka = 0;
	    i__2 = l_init__;
	    for (i__ = 1; i__ <= i__2; ++i__) {
		k = il + i__ - 1;
/* [1,n_ali] common aligned */
		r_1__[i__ * 3 - 3] = xa[align_1.ia[k - 1] - 1];
		r_1__[i__ * 3 - 2] = ya[align_1.ia[k - 1] - 1];
		r_1__[i__ * 3 - 1] = za[align_1.ia[k - 1] - 1];
		r_2__[i__ * 3 - 3] = stru_1.xb[align_1.ib[k - 1] - 1];
		r_2__[i__ * 3 - 2] = stru_1.yb[align_1.ib[k - 1] - 1];
		r_2__[i__ * 3 - 1] = stru_1.zb[align_1.ib[k - 1] - 1];
		++ll;
		++ka;
		k_ali__[ka - 1] = k;
	    }
	    u3b_(w, r_1__, r_2__, &ll, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
	    if (i_init__ == 1) {
/* global superposition */
		armsd = sqrt(rms / ll);
		*rcomm = armsd;
	    }
	    i__2 = nseqa;
	    for (j = 1; j <= i__2; ++j) {
		stru_1.xt[j - 1] = t[0] + u[0] * xa[j - 1] + u[3] * ya[j - 1] 
			+ u[6] * za[j - 1];
		stru_1.yt[j - 1] = t[1] + u[1] * xa[j - 1] + u[4] * ya[j - 1] 
			+ u[7] * za[j - 1];
		stru_1.zt[j - 1] = t[2] + u[2] * xa[j - 1] + u[5] * ya[j - 1] 
			+ u[8] * za[j - 1];
	    }
	    d__ = d0_search__ - 1;
/* reduce the search rms first */
	    cal_tmscore__(&d__, &d0, &n_ali__, &nstat, &score, i_ali__, &
		    n_cut__);
/* init, get scores, n_cut+i_ali(i) for iteration */
	    if (score_max__ < score) {
		score_max__ = score;
		ka0 = ka;
		i__2 = ka0;
		for (i__ = 1; i__ <= i__2; ++i__) {
		    k_ali0__[i__ - 1] = k_ali__[i__ - 1];
/* alignment stored */
		}
	    }
/* ccc  iteration for extending */
	    d__ = d0_search__ + 1;
	    i__2 = n_it__;
	    for (it = 1; it <= i__2; ++it) {
		ll = 0;
		ka = 0;
		i__4 = n_cut__;
		for (i__ = 1; i__ <= i__4; ++i__) {
		    m = i_ali__[i__ - 1];
/* [1,n_ali] */
		    r_1__[i__ * 3 - 3] = xa[align_1.ia[m - 1] - 1];
		    r_1__[i__ * 3 - 2] = ya[align_1.ia[m - 1] - 1];
		    r_1__[i__ * 3 - 1] = za[align_1.ia[m - 1] - 1];
		    r_2__[i__ * 3 - 3] = stru_1.xb[align_1.ib[m - 1] - 1];
		    r_2__[i__ * 3 - 2] = stru_1.yb[align_1.ib[m - 1] - 1];
		    r_2__[i__ * 3 - 1] = stru_1.zb[align_1.ib[m - 1] - 1];
		    ++ka;
		    k_ali__[ka - 1] = m;
		    ++ll;
		}
		u3b_(w, r_1__, r_2__, &ll, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
		i__4 = nseqa;
		for (j = 1; j <= i__4; ++j) {
		    stru_1.xt[j - 1] = t[0] + u[0] * xa[j - 1] + u[3] * ya[j 
			    - 1] + u[6] * za[j - 1];
		    stru_1.yt[j - 1] = t[1] + u[1] * xa[j - 1] + u[4] * ya[j 
			    - 1] + u[7] * za[j - 1];
		    stru_1.zt[j - 1] = t[2] + u[2] * xa[j - 1] + u[5] * ya[j 
			    - 1] + u[8] * za[j - 1];
		}
		cal_tmscore__(&d__, &d0, &n_ali__, &nstat, &score, i_ali__, &
			n_cut__);
/* get scores, n_cut+i_ali(i) for iteration */
		if (score_max__ < score) {
		    score_max__ = score;
		    ka0 = ka;
		    i__4 = ka;
		    for (i__ = 1; i__ <= i__4; ++i__) {
			k_ali0__[i__ - 1] = k_ali__[i__ - 1];
		    }
		}
		if (it == n_it__) {
		    goto L302;
		}
		if (n_cut__ == ka) {
		    neq = 0;
		    i__4 = n_cut__;
		    for (i__ = 1; i__ <= i__4; ++i__) {
			if (i_ali__[i__ - 1] == k_ali__[i__ - 1]) {
			    ++neq;
			}
		    }
		    if (n_cut__ == neq) {
			goto L302;
		    }
		}
/* L301: */
	    }
/* for iteration */
L302:
/* L300: */
	    ;
	}
/* for shift */
/* L333: */
    }
/* ccc  return the final rotation with rotated (xtm1 or x1) */
/* for initial length, L_ali/M */
    ll = 0;
    i__1 = ka0;
    for (i__ = 1; i__ <= i__1; ++i__) {
	m = k_ali0__[i__ - 1];
/* record of the best alignment */
	r_1__[i__ * 3 - 3] = xa[align_1.ia[m - 1] - 1];
	r_1__[i__ * 3 - 2] = ya[align_1.ia[m - 1] - 1];
	r_1__[i__ * 3 - 1] = za[align_1.ia[m - 1] - 1];
	r_2__[i__ * 3 - 3] = stru_1.xb[align_1.ib[m - 1] - 1];
	r_2__[i__ * 3 - 2] = stru_1.yb[align_1.ib[m - 1] - 1];
	r_2__[i__ * 3 - 1] = stru_1.zb[align_1.ib[m - 1] - 1];
	++ll;
    }
    u3b_(w, r_1__, r_2__, &ll, &c__1, &rms, u, t, &ier);
/* u rotate r_1 to r_2 */
    i__1 = nseqa;
    for (j = 1; j <= i__1; ++j) {
	x1[j] = t[0] + u[0] * xa[j - 1] + u[3] * ya[j - 1] + u[6] * za[j - 1];
	y1[j] = t[1] + u[1] * xa[j - 1] + u[4] * ya[j - 1] + u[7] * za[j - 1];
	z1[j] = t[2] + u[2] * xa[j - 1] + u[5] * ya[j - 1] + u[8] * za[j - 1];
    }
    *tm = score_max__;
    return 0;
} /* tmsearch_ */

/* ccc rotuine to calculate TM-score given the superposed coordinates */
/* ccc IMP: superposed coordinates are passed in common */
/* ccc d is for selecting the residues with certain cutoff and d0 is for */
/* ccc TM-score calculation. nstat is type of calculation d or d8 */
/* Subroutine */ int cal_tmscore__(real *d__, real *d0, integer *n_ali__, 
	logical *nstat, doublereal *score, integer *i_ali__, integer *n_cut__)
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2, r__3;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer i__, j, k;
    static real score_sum__, dis, d_cp__;
    static integer nseqb;

    /* Parameter adjustments */
    --i_ali__;

    /* Function Body */
    d_cp__ = *d__;
/* for preventing superposition of 2 residues and less */
    nseqb = *n_ali__;
/* normalized for TMscore */
L116:
    *n_cut__ = 0;
/* number of residue-pairs dis<d, for iteration */
    score_sum__ = (float)0.;
/* TMscore */
    i__1 = *n_ali__;
    for (k = 1; k <= i__1; ++k) {
	i__ = align_1.ia[k - 1];
/* [1,nseqA] reoder number of structureA */
	j = align_1.ib[k - 1];
/* [1,nseqB] */
/* Computing 2nd power */
	r__1 = stru_1.xt[i__ - 1] - stru_1.xb[j - 1];
/* Computing 2nd power */
	r__2 = stru_1.yt[i__ - 1] - stru_1.yb[j - 1];
/* Computing 2nd power */
	r__3 = stru_1.zt[i__ - 1] - stru_1.zb[j - 1];
	dis = sqrt(r__1 * r__1 + r__2 * r__2 + r__3 * r__3);
	if (dis < d_cp__) {
	    ++(*n_cut__);
	    i_ali__[*n_cut__] = k;
/* [1,n_ali], mark the residue-pairs in dis<d */
	}
	if (*nstat) {
	    if (dis <= dinfo_1.d8) {
/* Computing 2nd power */
		r__1 = dis / *d0;
		score_sum__ += (float)1. / (r__1 * r__1 + 1);
	    }
	} else {
/* Computing 2nd power */
	    r__1 = dis / *d0;
	    score_sum__ += (float)1. / (r__1 * r__1 + 1);
	}
    }
    if (*n_cut__ > 0 && *n_cut__ < 3) {
	d_cp__ += (float).5;
	goto L116;
    }
    *score = score_sum__;
/* TM-score */
    return 0;
} /* cal_tmscore__ */

/* ccccccccccccccc Calculate sum of (r_d-r_m)^2 cccccccccccccccccccccccccc */
/*  w    - w(m) is weight for atom pair  c m           (given) */
/*  x    - x(i,m) are coordinates of atom c m in set x       (given) */
/*  y    - y(i,m) are coordinates of atom c m in set y       (given) */
/*  n    - n is number of atom pairs                         (given) */
/*  mode  - 0:calculate rms only                             (given) */
/*          1:calculate rms,u,t                              (takes longer) */
/*  rms   - sum of w*(ux+t-y)**2 over all atom pairs         (result) */
/*  u    - u(i,j) is   rotation  matrix for best superposition  (result) */
/*  t    - t(i)   is translation vector for best superposition  (result) */
/*  ier  - 0: a unique optimal superposition has been determined(result) */
/*       -1: superposition is not unique but optimal */
/*       -2: no result obtained because of negative weights w */
/*           or all weights equal to zero. */
/* ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc */
/* Subroutine */ int u3b_(doublereal *w, doublereal *x, doublereal *y, 
	integer *n, integer *mode, doublereal *rms, doublereal *u, doublereal 
	*t, integer *ier)
{
    /* Initialized data */

    static doublereal sqrt3 = 1.73205080756888;
    static doublereal tol = .01;
    static doublereal zero = 0.;
    static doublereal one = 1.;
    static doublereal two = 2.;
    static doublereal three = 3.;
    static integer ip[9] = { 1,2,4,2,3,5,4,5,6 };
    static integer ip2312[4] = { 2,3,1,2 };

    /* System generated locals */
    integer i__1;
    doublereal d__1, d__2;
    static doublereal equiv_5[6], equiv_11[6], equiv_14[3];

    /* Builtin functions */
    double sqrt(doublereal), atan2(doublereal, doublereal), cos(doublereal), 
	    sin(doublereal);

    /* Local variables */
    static doublereal a[9]	/* was [3][3] */, b[9]	/* was [3][3] */, d__;
#define e (equiv_14)
    static doublereal g, h__;
    static integer i__, j, k, l, m;
    static doublereal p, r__[9]	/* was [3][3] */, e0;
#define e1 (equiv_14)
#define e2 (equiv_14 + 1)
#define e3 (equiv_14 + 2)
    static integer m1;
    static doublereal wc, xc[3], yc[3];
#define rr (equiv_5)
#define ss (equiv_11)
#define rr1 (equiv_5)
#define rr2 (equiv_5 + 1)
#define rr3 (equiv_5 + 2)
#define rr4 (equiv_5 + 3)
#define rr5 (equiv_5 + 4)
#define rr6 (equiv_5 + 5)
#define ss1 (equiv_11)
#define ss2 (equiv_11 + 1)
#define ss3 (equiv_11 + 2)
#define ss4 (equiv_11 + 3)
#define ss5 (equiv_11 + 4)
#define ss6 (equiv_11 + 5)
    static doublereal cof, det, cth, sth, spur, sigma, sqrth;

    /* Parameter adjustments */
    y -= 4;
    x -= 4;
    --w;
    u -= 4;
    --t;

    /* Function Body */
/* 156 "rms.for" */
    wc = zero;
    *rms = (float)0.;
    e0 = zero;
    for (i__ = 1; i__ <= 3; ++i__) {
	xc[i__ - 1] = zero;
	yc[i__ - 1] = zero;
	t[i__] = (float)0.;
	for (j = 1; j <= 3; ++j) {
	    d__ = zero;
	    if (i__ == j) {
		d__ = one;
	    }
	    u[i__ + j * 3] = d__;
	    a[i__ + j * 3 - 4] = d__;
/* L1: */
	    r__[i__ + j * 3 - 4] = zero;
	}
    }
    *ier = -1;
/* **** DETERMINE CENTROIDS OF BOTH VECTOR SETS X AND Y */
/* 170 "rms.for" */
    if (*n < 1) {
	return 0;
    }
/* 172 "rms.for" */
    *ier = -2;
    i__1 = *n;
    for (m = 1; m <= i__1; ++m) {
	if (w[m] < (float)0.) {
	    return 0;
	}
	wc += w[m];
	for (i__ = 1; i__ <= 3; ++i__) {
	    xc[i__ - 1] += w[m] * x[i__ + m * 3];
/* L2: */
	    yc[i__ - 1] += w[m] * y[i__ + m * 3];
	}
    }
    if (wc <= zero) {
	return 0;
    }
    for (i__ = 1; i__ <= 3; ++i__) {
	xc[i__ - 1] /= wc;
/* **** DETERMINE CORRELATION MATRIX R BETWEEN VECTOR SETS Y AND X */
/* 182 "rms.for" */
/* L3: */
	yc[i__ - 1] /= wc;
    }
/* 184 "rms.for" */
    i__1 = *n;
    for (m = 1; m <= i__1; ++m) {
	for (i__ = 1; i__ <= 3; ++i__) {
/* Computing 2nd power */
	    d__1 = x[i__ + m * 3] - xc[i__ - 1];
/* Computing 2nd power */
	    d__2 = y[i__ + m * 3] - yc[i__ - 1];
	    e0 += w[m] * (d__1 * d__1 + d__2 * d__2);
/* 187 "rms.for" */
	    d__ = w[m] * (y[i__ + m * 3] - yc[i__ - 1]);
	    for (j = 1; j <= 3; ++j) {
/* **** CALCULATE DETERMINANT OF R(I,J) */
/* 189 "rms.for" */
/* L4: */
		r__[i__ + j * 3 - 4] += d__ * (x[j + m * 3] - xc[j - 1]);
	    }
	}
    }
/* 191 "rms.for" */
    det = r__[0] * (r__[4] * r__[8] - r__[7] * r__[5]) - r__[3] * (r__[1] * 
	    r__[8] - r__[7] * r__[2]) + r__[6] * (r__[1] * r__[5] - r__[4] * 
	    r__[2]);
/* **** FORM UPPER TRIANGLE OF TRANSPOSED(R)*R */
/* 194 "rms.for" */
    sigma = det;
/* 196 "rms.for" */
    m = 0;
    for (j = 1; j <= 3; ++j) {
	i__1 = j;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    ++m;
/* ***************** EIGENVALUES ***************************************** */
/* **** FORM CHARACTERISTIC CUBIC  X**3-3*SPUR*X**2+3*COF*X-DET=0 */
/* 200 "rms.for" */
/* L5: */
	    rr[m - 1] = r__[i__ * 3 - 3] * r__[j * 3 - 3] + r__[i__ * 3 - 2] *
		     r__[j * 3 - 2] + r__[i__ * 3 - 1] * r__[j * 3 - 1];
	}
    }
/* 203 "rms.for" */
    spur = (*rr1 + *rr3 + *rr6) / three;
    cof = (*rr3 * *rr6 - *rr5 * *rr5 + *rr1 * *rr6 - *rr4 * *rr4 + *rr1 * *
	    rr3 - *rr2 * *rr2) / three;
/* 205 "rms.for" */
    det *= det;
    for (i__ = 1; i__ <= 3; ++i__) {
/* L6: */
	e[i__ - 1] = spur;
    }
/* **** REDUCE CUBIC TO STANDARD FORM Y**3-3HY+2G=0 BY PUTTING X=Y+SPUR */
/* 208 "rms.for" */
    if (spur <= zero) {
	goto L40;
    }
/* 210 "rms.for" */
    d__ = spur * spur;
    h__ = d__ - cof;
/* **** SOLVE CUBIC. ROOTS ARE E1,E2,E3 IN DECREASING ORDER */
/* 212 "rms.for" */
    g = (spur * cof - det) / two - spur * h__;
/* 214 "rms.for" */
    if (h__ <= zero) {
	goto L8;
    }
    sqrth = sqrt(h__);
    d__ = h__ * h__ * h__ - g * g;
    if (d__ < zero) {
	d__ = zero;
    }
    d__ = atan2(sqrt(d__), -g) / three;
    cth = sqrth * cos(d__);
    sth = sqrth * sqrt3 * sin(d__);
    *e1 = spur + cth + cth;
    *e2 = spur - cth + sth;
    *e3 = spur - cth - sth;
/* .....HANDLE SPECIAL CASE OF 3 IDENTICAL ROOTS */
/* 224 "rms.for" */
    if (*mode != 0) {
	goto L10;
    } else {
	goto L50;
    }
/* **************** EIGENVECTORS ***************************************** */
/* 226 "rms.for" */
L8:
    if (*mode != 0) {
	goto L30;
    } else {
	goto L50;
    }
/* 228 "rms.for" */
L10:
    for (l = 1; l <= 3; l += 2) {
	d__ = e[l - 1];
	*ss1 = (d__ - *rr3) * (d__ - *rr6) - *rr5 * *rr5;
	*ss2 = (d__ - *rr6) * *rr2 + *rr4 * *rr5;
	*ss3 = (d__ - *rr1) * (d__ - *rr6) - *rr4 * *rr4;
	*ss4 = (d__ - *rr3) * *rr4 + *rr2 * *rr5;
	*ss5 = (d__ - *rr1) * *rr5 + *rr2 * *rr4;
	*ss6 = (d__ - *rr1) * (d__ - *rr3) - *rr2 * *rr2;
	j = 1;
	if (abs(*ss1) >= abs(*ss3)) {
	    goto L12;
	}
	j = 2;
	if (abs(*ss3) >= abs(*ss6)) {
	    goto L13;
	}
L11:
	j = 3;
	goto L13;
L12:
	if (abs(*ss1) < abs(*ss6)) {
	    goto L11;
	}
L13:
	d__ = zero;
	j = (j - 1) * 3;
	for (i__ = 1; i__ <= 3; ++i__) {
	    k = ip[i__ + j - 1];
	    a[i__ + l * 3 - 4] = ss[k - 1];
/* L14: */
	    d__ += ss[k - 1] * ss[k - 1];
	}
	if (d__ > zero) {
	    d__ = one / sqrt(d__);
	}
	for (i__ = 1; i__ <= 3; ++i__) {
/* L15: */
	    a[i__ + l * 3 - 4] *= d__;
	}
    }
    d__ = a[0] * a[6] + a[1] * a[7] + a[2] * a[8];
    m1 = 3;
    m = 1;
    if (*e1 - *e2 > *e2 - *e3) {
	goto L16;
    }
    m1 = 1;
    m = 3;
L16:
    p = zero;
    for (i__ = 1; i__ <= 3; ++i__) {
	a[i__ + m1 * 3 - 4] -= d__ * a[i__ + m * 3 - 4];
/* L17: */
/* Computing 2nd power */
	d__1 = a[i__ + m1 * 3 - 4];
	p += d__1 * d__1;
    }
    if (p <= tol) {
	goto L19;
    }
    p = one / sqrt(p);
    for (i__ = 1; i__ <= 3; ++i__) {
/* L18: */
	a[i__ + m1 * 3 - 4] *= p;
    }
    goto L21;
L19:
    p = one;
    for (i__ = 1; i__ <= 3; ++i__) {
	if (p < (d__1 = a[i__ + m * 3 - 4], abs(d__1))) {
	    goto L20;
	}
	p = (d__1 = a[i__ + m * 3 - 4], abs(d__1));
	j = i__;
L20:
	;
    }
    k = ip2312[j - 1];
    l = ip2312[j];
/* Computing 2nd power */
    d__1 = a[k + m * 3 - 4];
/* Computing 2nd power */
    d__2 = a[l + m * 3 - 4];
    p = sqrt(d__1 * d__1 + d__2 * d__2);
    if (p <= tol) {
	goto L40;
    }
    a[j + m1 * 3 - 4] = zero;
    a[k + m1 * 3 - 4] = -(a[l + m * 3 - 4] / p);
    a[l + m1 * 3 - 4] = a[k + m * 3 - 4] / p;
L21:
    a[3] = a[7] * a[2] - a[1] * a[8];
    a[4] = a[8] * a[0] - a[2] * a[6];
/* ****************** ROTATION MATRIX ************************************ */
/* 282 "rms.for" */
    a[5] = a[6] * a[1] - a[0] * a[7];
/* 284 "rms.for" */
L30:
    for (l = 1; l <= 2; ++l) {
	d__ = zero;
	for (i__ = 1; i__ <= 3; ++i__) {
	    b[i__ + l * 3 - 4] = r__[i__ - 1] * a[l * 3 - 3] + r__[i__ + 2] * 
		    a[l * 3 - 2] + r__[i__ + 5] * a[l * 3 - 1];
/* 288 "rms.for" */
/* L31: */
/* Computing 2nd power */
	    d__1 = b[i__ + l * 3 - 4];
	    d__ += d__1 * d__1;
	}
	if (d__ > zero) {
	    d__ = one / sqrt(d__);
	}
	for (i__ = 1; i__ <= 3; ++i__) {
/* L32: */
	    b[i__ + l * 3 - 4] *= d__;
	}
    }
    d__ = b[0] * b[3] + b[1] * b[4] + b[2] * b[5];
    p = zero;
    for (i__ = 1; i__ <= 3; ++i__) {
	b[i__ + 2] -= d__ * b[i__ - 1];
/* L33: */
/* Computing 2nd power */
	d__1 = b[i__ + 2];
	p += d__1 * d__1;
    }
    if (p <= tol) {
	goto L35;
    }
    p = one / sqrt(p);
    for (i__ = 1; i__ <= 3; ++i__) {
/* L34: */
	b[i__ + 2] *= p;
    }
    goto L37;
L35:
    p = one;
    for (i__ = 1; i__ <= 3; ++i__) {
	if (p < (d__1 = b[i__ - 1], abs(d__1))) {
	    goto L36;
	}
	p = (d__1 = b[i__ - 1], abs(d__1));
	j = i__;
L36:
	;
    }
    k = ip2312[j - 1];
    l = ip2312[j];
/* Computing 2nd power */
    d__1 = b[k - 1];
/* Computing 2nd power */
    d__2 = b[l - 1];
    p = sqrt(d__1 * d__1 + d__2 * d__2);
    if (p <= tol) {
	goto L40;
    }
    b[j + 2] = zero;
    b[k + 2] = -(b[l - 1] / p);
    b[l + 2] = b[k - 1] / p;
L37:
    b[6] = b[1] * b[5] - b[4] * b[2];
    b[7] = b[2] * b[3] - b[5] * b[0];
    b[8] = b[0] * b[4] - b[3] * b[1];
    for (i__ = 1; i__ <= 3; ++i__) {
	for (j = 1; j <= 3; ++j) {
/* ****************** TRANSLATION VECTOR ********************************* */
/* 320 "rms.for" */
/* L39: */
	    u[i__ + j * 3] = b[i__ - 1] * a[j - 1] + b[i__ + 2] * a[j + 2] + 
		    b[i__ + 5] * a[j + 5];
	}
    }
L40:
    for (i__ = 1; i__ <= 3; ++i__) {
/* ********************** RMS ERROR ************************************** */
/* 323 "rms.for" */
/* L41: */
	t[i__] = yc[i__ - 1] - u[i__ + 3] * xc[0] - u[i__ + 6] * xc[1] - u[
		i__ + 9] * xc[2];
    }
L50:
    for (i__ = 1; i__ <= 3; ++i__) {
	if (e[i__ - 1] < zero) {
	    e[i__ - 1] = zero;
	}
/* L51: */
	e[i__ - 1] = sqrt(e[i__ - 1]);
    }
    *ier = 0;
    if (*e2 <= *e1 * 1e-5) {
	*ier = -1;
    }
    d__ = *e3;
    if (sigma >= (float)0.) {
	goto L52;
    }
    d__ = -d__;
    if (*e2 - *e3 <= *e1 * 1e-5) {
	*ier = -1;
    }
L52:
    d__ = d__ + *e2 + *e1;
    *rms = e0 - d__ - d__;
    if (*rms < (float)0.) {
	*rms = (float)0.;
    }
    return 0;
/* .....END U3B........................................................... */
/* ---------------------------------------------------------- */
/*                       THE END */
/* ---------------------------------------------------------- */
/* 338 "rms.for" */
} /* u3b_ */

#undef ss6
#undef ss5
#undef ss4
#undef ss3
#undef ss2
#undef ss1
#undef rr6
#undef rr5
#undef rr4
#undef rr3
#undef rr2
#undef rr1
#undef ss
#undef rr
#undef e3
#undef e2
#undef e1
#undef e


/* Main program alias */ int frtmalign_ ( int *aln2_length, double *aln2_rmsd, double *aln2_tmscore, double *aln2_identity, int length2a, int length2b, char seqa2a[], char seqa2b[], int align2[], int ires2a[], int ires2b[], double xyz2a[][3], double xyz2b[][3], double tt2[], double uu2[][3], int length2c )
{ 
 double xyz2c[MAXPRO*3];
 double xyz2d[MAXPRO*3];
 
 for ( int ii2 = 0; ii2 < length2a; ii2++ )
  for ( int ii5 = 0; ii5 < 3; ii5++ )
   xyz2c[ii2*3+ii5] = xyz2a[ii2][ii5];
 
 for ( int ii2 = 0; ii2 < length2b; ii2++ )
  for ( int ii5 = 0; ii5 < 3; ii5++ )
   xyz2d[ii2*3+ii5] = xyz2b[ii2][ii5];
 
 int align2a[MAXPRO][2];
 
 MAIN_FR__ ( &(*aln2_length), &(*aln2_rmsd), &(*aln2_tmscore), &(*aln2_identity), length2a, length2b, tt2, uu2, xyz2c, xyz2d, seqa2a, seqa2b, ires2a, ires2b, align2a, length2c );
 
 for ( int ii2 = 0; ii2 < length2b; ii2++ )
 {
  align2[ii2] = -1;
 }
 
 for ( int ii2 = 0; ii2 < *aln2_length; ii2++ )
  align2[align2a[ii2][1]] = align2a[ii2][0];
 
 return 0;
}

#ifdef __cplusplus
	}
#endif
